;|=================================================[  UhspFile.as       ]=====|
#ifndef        __UHSP_FILE__
#define global __UHSP_FILE__
;|========.===========================.============[                    ]=====|
#uselib  "advapi32.dll"
#func   global __CryptAcquireContext       "CryptAcquireContextA"      sptr,sptr,sptr,sptr,sptr
#func   global __CryptCreateHash           "CryptCreateHash"           sptr,sptr,sptr,sptr,sptr
#func   global __CryptDestroyHash          "CryptDestroyHash"          sptr
#func   global __CryptGetHashParam         "CryptGetHashParam"         sptr,sptr,sptr,sptr,sptr
#func   global __CryptHashData             "CryptHashData"             sptr,sptr,sptr,sptr
#func   global __CryptReleaseContext       "CryptReleaseContext"       sptr,sptr
;|========.===========================.============[                    ]=====|
#ifndef        __UHSP_FUNC__
#include "UhspFunc.as"
#endif
;|========.===========================.============[                    ]=====|
#module   File
#deffunc  File_Save1 str p1,array p2,int p3,int p4,local ss,local ii,local rr
          exist  p1 :ss  =  strsize               :ii  =  length(p2)
                 if (ss  <  0) or (p3  ==  0)     {bsave  p1,p2,0}             :bsave p1,p2,ii*(4*(p4+1)),p3 :rr = p3+ii*(4*(p4+1))
return  rr
#deffunc  File_Load1 str p1,array p2,int p3,int p4,local ss,local ii,local rr
          exist  p1 :ss  =  strsize               :if (ss <=  0) {return -1}
                     ii  =  length(p2)                                         :bload p1,p2,ii*(4*(p4+1)),p3 :rr = p3+ii*(4*(p4+1))
return  rr
#deffunc  File_Save2 str p1,array p2,int p3,local ss,local ii,local nn,local rr
          exist  p1 :ss  =  strsize               :ii  =  length(p2) :rr  = p3
                 if (ss  <  0) or (p3  ==  0)     {bsave  p1,p2,0}
          repeat ii :nn  =  strlen@hsp(p2(cnt))+1 :bsave  p1,nn,4,rr :rr +=  4 :bsave p1,p2(cnt),nn,rr       :rr+= nn :loop
return  rr
#deffunc  File_Load2 str p1,array p2,int p3,local ss,local ii,local nn,local rr
          exist  p1 :ss  =  strsize               :if (ss  <  0) {return -1}
                     ii  =  length(p2)            :rr  =  p3
          repeat ii :nn  =  strlen@hsp(p2(cnt))+1 :bload  p1,nn,4,rr :rr +=  4 :bload p1,p2(cnt),nn,rr       :rr+= nn :loop
return  rr
;|========.===========================.============[                    ]=====|
#defcfunc File_Drives local ii,local rr
          __GetLogicalDrives        :ii    = stat,0,0,0
          repeat 32 :if (1<<cnt&ii) {rr    = strf("%c:",65+cnt) :__GetVolumeInformationA rr+"/",0,0,0,0,0,0,0
                                    :rr(1)+= rr+","  :ii(2)+= stat<<ii(1):ii(1)++} :loop:rr = rr(1)+str(ii(2))
return  rr
#deffunc  File_TimeTo array p1,int p2,str p3,local ss
          if (p2) {if (p3 != "") {
                   wpoke p1, 0,int(Func_Split(p3+",,,,,,",",",ss,1))
                   wpoke p1, 2,int(ss(1))   :wpoke p1, 6,int(ss(2))  :wpoke p1,8,int(ss(3))
                   wpoke p1,10,int(ss(4))   :wpoke p1,12,int(ss(5))  :wpoke p1,4,0 :wpoke p1,14,0}
                      __SystemTimeToFileTime varptr(p1),varptr(p1)
                   __LocalFileTimeToFileTime varptr(p1),varptr(p1)}
        else      {__FileTimeToLocalFileTime varptr(p1),varptr(p1)   :p1(2) = 0,0
                      __FileTimeToSystemTime varptr(p1),varptr(p1)
          _Hstr@Func  =  strf("%4d,%02d,%02d,%02d,%02d,%02d,%d",wpeek(p1,0),wpeek(p1,2),wpeek(p1,6),wpeek(p1,8),wpeek(p1,10),wpeek(p1,12),wpeek(p1,4))}
return
#defcfunc File_Time str p1,int p2,local ss,local ii,local jj,local nn
              ss   = p1  :dim nn,80  :__FindFirstFileA varptr(ss),varptr(nn)  :ii = stat :__FindClose ii
          if (ii  == -1) {return ""} :  if (p2  ==  0) {jj = nn(5),nn(6)} else:if (p2  ==  1) {jj = nn(3),nn(4)} else { jj = nn(1),nn(2)}
                          File_TimeTo jj,0,""                                 :ii = 0
          repeat 6       :if (cnt ==  2) {ii+= 2} :ss(cnt)  =  wpeek(jj,ii)   :ii+= 2 :loop
return    strf("%04d,%02d,%02d,%02d,%02d,%02d",ss(0),ss(1),ss(2),ss(3),ss(4),ss(5))
#defcfunc File_Lock str p1,int p2,local rr                              ;__GetFileSize rr,varptr(nn):nn(1)=stat:__LockFile rr,0,0,nn(1),nn
          if (p2 == 0) {__CreateFileA p1,$80000000,0,0,3,0,0 :rr = stat :__LockFile rr,0,0,0,0}
        else           {__UnLockFile  p2,0,0,0,0             :rr = stat :__CloseHandle p2}
return  rr
#defcfunc File_Argc array p1,local ii,local jj,local nn,local rr
          __GetCommandLineW          :ii = stat :__CommandLineToArgvW ii,varptr(rr)
          if (stat == 0) {return 0}  :ii = stat :  dupptr jj,ii,4*rr,4
          repeat rr :dupptr nn,jj(cnt),256,2    :  p1(cnt) = cnvwtos(nn) :loop
          __LocalFree ii
return  rr
#defcfunc File_Exec str p1,int p2,local ii,local jj
          switch p2
            case 1 :case  2 :        :dim ii,17       :       ii(11) = 1,5    : jj = 0,0,0,0
                     __CreateProcessA 0,p1,0,0,0,0,0,0,varptr(ii),varptr(jj)  :_Ures@Func = jj(2)
                      if (stat == 0) {return -1}      :__WaitForInputIdle       jj,-1
                      if (p2   == 1) {swbreak  } else {__WaitForSingleObject    jj,-1
                     __CloseHandle jj(1)              :__CloseHandle            jj} :swbreak
            default:__TerminateProcess p2,0                                         :swbreak
          swend
return  jj
#defcfunc File_GetDrop local ii,local ss,local rr,local nn
                                      nn  = 0,0 :__DragQueryFileA  wparam,-1,0,0    :ii   = stat
          if (ii  > 0) {sdim ss,512 :ss  = ""   :__DragQueryPoint  wparam,varptr(nn)
                        sdim rr,512 :rr  = "" +ii+","+nn+","+nn(1)+"\n"
                 repeat ii                      :__DragQueryFileA  wparam,cnt,varptr(ss),512
                        rr += ss+"\n":loop}     :__DragFinish      wparam     :_Hstr@Func = rr
return  ii
#defcfunc File_Crypt var p1,int p2,int p3,local ss,local ii,local jj,local nn
          sdim ss,,3   :ii(3) = p2         :if (p2 == 0) {ii(3) = strlen@hsp(p1)}
          if (p3 == 1) {ii(2) = $8001} else:if (p3 == 2) {ii(2) = $8002}  else:if (p3 == 3) {ii(2) = $8004} else {ii(2) = $8003} ;MD2,MD4-SHA,MD5
                        __CryptAcquireContext   varptr(ii(0)),0,0,$1,$F0000000|$20
          if (stat   ) {__CryptCreateHash        ii(0),ii(2),0,0,varptr(ii(1))
          if (stat   ) {__CryptHashData          ii(1),varptr(p1),ii(3),0
          if (stat   ) {__CryptGetHashParam      ii(1),$2,0 ,varptr(jj),0     :dim nn,jj/4
          if (stat   ) {__CryptGetHashParam      ii(1),$2   ,varptr(nn),varptr(jj),0
          if (stat   ) {  foreach nn            :ss(0) = strf("%08X",nn(cnt)) :ss(1) = ""
                               repeat strlen@hsp(ss(0))/2                     :ss(1) = strmid(ss(0),cnt*2,2)+ss(1) :loop :ss(2)+= ss(1) :loop}}}}}
                       :__CryptDestroyHash ii(1):__CryptDestroyHash ii
return  ss(2)
#defcfunc File_XorCrypt str p1,int p2,local ss,local rr
          ss  =  p1    :  randomize p2          :repeat Func_SizeOf(ss)       :rr    = peek(ss,cnt)^rnd(256) :poke ss,cnt,rr :loop
return  ss
;|========.===========================.============[                    ]=====|
#define global       _Save(%1="",%2=0,%3=0)          _Uany@Func  = %2  :\
                                         if (vartype(_Uany@Func) == 2) {File_Save2 %1,%2,%3  } :if (vartype(_Uany@Func) == 3) {File_Save1 %1,%2,%3,1} :\
                                         if (vartype(_Uany@Func) == 4) {File_Save1 %1,%2,%3,0} :if (vartype(_Uany@Func) == 1) {File_Save1 %1,%2,%3,0}
#define global       _Load(%1="",%2=0,%3=0)          _Uany@Func  = %2  :\
                                         if (vartype(_Uany@Func) == 2) {File_Load2 %1,%2,%3  } :if (vartype(_Uany@Func) == 3) {File_Load1 %1,%2,%3,1} :\
                                         if (vartype(_Uany@Func) == 4) {File_Load1 %1,%2,%3,0} :if (vartype(_Uany@Func) == 1) {File_Load1 %1,%2,%3,0}
#define global ctype _Drives                                            File_Drives()
#define global       _TimeTo(%1=0,%2=0,%3="")                           File_TimeTo %1,%2,%3
#define global ctype _Stamp(%1="",%2=0)                                 File_Time(%1,%2)
#define global ctype _Lock(%1="",%2=0)                                  File_Lock(%1,%2)
#define global ctype _Argc(%1=_Ures@Func)                               File_Argc(%1)
#define global ctype _Exec(%1="calc",%2=1)                              File_Exec(%1,%2)
#define global       _SetDrop(%1=hwnd,%2=0) __DragAcceptFiles %1,%2
#define global ctype _GetDrop                                           File_GetDrop()
#define global ctype _Crypt(%1=0,%2=0,%3=0)                             File_Crypt(%1,%2,%3)
#define global ctype _Crypt2(%1="",%2=0)                                File_XorCrypt(%1,%2)
;|============================================================================|
#global
#endif
