;|=================================================[  UhspGdis.as       ]=====|
#ifndef        __UHSP_GDIS__
#define global __UHSP_GDIS__
#ifndef        __UHSP_FUNC__
#include "UhspFunc.as"
#endif
;|========.===========================.============[                    ]=====|
#module   Gdis
#defcfunc Gdis_IcoCreate int p1,int p2,int p3,int p4,int p5,int p6,local nn,local rr
          __GetDC 0                            :nn    =  stat
          __CreateCompatibleDC     nn          :nn(1) =  stat
          __CreateCompatibleBitmap nn,p1,p2    :rr    =  stat
          __SelectObject           nn(1),rr    :nn(2) =  stat
                          __BitBlt nn(1),0,0,p1,p2,Func_Winfo(_HWND_SCREEN,_Mint@Func,p6,4,""),p3,p4,$00CC0020
          __CreateBitmap           p1,p2,1,1,0 :rr(1) =  stat
          __SetBkColor             nn(1),p5
          __CreateCompatibleDC     nn(1)       :nn(3) =  stat
          __SelectObject           nn(3),rr(1) :nn(4) =  stat
                          __BitBlt nn(3),0,0,p1,p2,nn(1),0,0,$00CC0020
          __SelectObject           nn(3),nn(4) :__DeleteDC nn(3)
          __SelectObject           nn(1),nn(2) :__DeleteDC nn(1)
          __Releasedc 0,nn                     :nn    =  1,0,0,rr(1),rr
          __CreateIconIndirect varptr(nn)      :rr(2) =  stat
          __DeleteObject           rr
          __DeleteObject           rr(1)
return  rr(2)
#defcfunc Gdis_FntCreate str p1,int p2,int p3,int p4,int p5,int p6,int p7,int p8,int p9,int pa,int pb,int pc,int pd,int pe,local nn,local rr
           dim nn,16                        :     nn(0) = p2,p3,p4,p5,p6
          poke nn(5),0,p7  :poke nn(5),1,p8 :poke nn(5),2,p9 :poke nn(5),3,pa
          poke nn(6),0,pb  :poke nn(6),1,pc :poke nn(6),2,pd :poke nn(6),3,pe  :poke nn(7),0,p1 :__CreateFontIndirectA varptr(nn) :rr = stat
return  rr
#defcfunc Gdis_BshCreate int p1,int p2,int p3,local nn,local rr
                            nn = p1,p3,p2   :__CreateBrushIndirect varptr(nn)  :rr = stat
return  rr
#defcfunc Gdis_PenCreate int p1,int p2,int p3,int p4,int p5,int p6,local nn,local rr
          if (p4    != -1) {nn = p5,p3,p6   :__ExtCreatePen $10000 | p1 |p4,p2,varptr(nn),0,0}
        else               {nn = p1,p2,0,p3 :__CreatePenIndirect   varptr(nn)} :rr = stat
return  rr
#defcfunc Gdis_BmaCreate int p1,int p2,int p3,int p4,int p5,local ii,local jj,local nn,local ss,local rr
                 ii = p1*p2*4    :dim nn ,124/4              :nn    = 40,p1,p2,1|(32<<16),0,ii
          __CreateDIBSection 0,varptr(nn),0,varptr(jj),0,0   :rr    = stat
          dupptr ss,jj,ii,4      :Func_Bswap -3,p5           :ii(1) = 0,p2-1
          repeat ii/4            :await
               __GetPixel  hdc,p3   +ii(1),p4 +ii(2)         :ii(3) = stat
               __GetPixel  hdc,p3+p1+ii(1),p4 +ii(2)         :ii(4) = stat
                 if (ii(1) == p1-1) {ii(1) = 0:ii(2)--} else {ii(1)++}
          lpoke ss,cnt*4,(peek(ii(3),0)<<16) | (peek(ii(3),1)<<8) | (peek(ii(3),2)<<0) | (peek(ii(4),0)<<24) ;(RGBA)
          loop                   :Func_Bswap -1
return  rr
#defcfunc Gdis_GetStruct int p1,array p2,local rr
          __GetObjectA p1,0,0 :rr = stat :dim p2,rr/4 :__GetObjectA p1,rr,varptr(p2)
return  rr
;|========.===========================.============[                    ]=====|
#defcfunc Gdis_IcoExtr str p1,int p2,int p3,local ii,local jj,local rr
          if (p3    == -1) {__ExtractIconA  hInstance,p1,p2                   :rr = stat     :return rr}
                            __ExtractIconEx p1,p2,varptr(rr),varptr(jj),1     :if (p3      ) {return jj}
return  rr
#defcfunc Gdis_IcoPath str p1,int p2,local ii,local ss,local rr
          ss  =  Func_Rchr(p1,47,92,_Uany@Func)                               :dim rr,86
          if (p2    ==  1) {ii = $08000} else:if (p2 ==  2) {ii = $10000} else:if (p2 ==  3) {ii = $00001}
          __SHGetFileInfoA  ss,0,varptr(rr),$160,$100|$400|ii                 :if (rr      ) {getstr _Hstr@Func,rr,$110}
return  rr
#defcfunc Gdis_ImgLoad str p1,int p2,local ss,local rr
          if (p2    != 16) {repeat 3:__LoadImageA hinstance,p2,cnt,0,0,$4000      :if (stat) {return stat} :loop}
          ss  =  getpath(p1,16)     :  if (instr(ss,0,".ico") != -1) {rr = 1} else:if (instr(ss,0,".cur") != -1) {rr = 2}
                                    :__LoadImageA hinstance,p1, rr,0,0,p2         :rr = stat
return  rr
#deffunc  Gdis_BmpDraw int p1,int p2,int p3,int p4,local nn,local rr
          rr  =  Func_Winfo(_HWND_SCREEN,_Mint@Func,p1,4,"")         :if (rr    == -1) {return rr}
          __GetObjectA  p4, 0,0             :  rr(1) = stat          :if (rr(1) ==  0) {return -1} :dim nn,rr(1)/4
          __GetObjectA  p4,rr(1),varptr(nn) :__CreateCompatibleDC rr :rr(2) = stat
          __SelectObject   rr(2),p4         :__BitBlt hdc,p2,p3,nn(1),nn(2),rr(2),0,0,$CC0020
          __DeleteDC       rr(2)                                     :_ChkDraw
return
#deffunc  Gdis_IcoDraw int p1,int p2,int p3,int p4,int p5,int p6,int p7,int p8,int p9,local rr
          rr  =  Func_Winfo(_HWND_SCREEN,_Mint@Func,p1,4,"")         :if (rr    == -1) {return rr}
          __DrawIconEx  rr,p2,p3,p4,p5,p6,p7,p8,p9                   :_ChkDraw
return
;|========.===========================.============[                    ]=====|
#define global ctype _IcoCreate(%1=32,%2=32,%3=0,%4=0,%5=0,%6=0)               Gdis_IcoCreate(%1,%2,%3,%4,%5,%6)
#define global ctype _FntCreate(%1=msmincho,%2=13,%3=0,%4=0,%5=0,%6=400,%7=0,%8=0,%9=0,%10=128,%11=0,%12=0,%13=2,%14=49) Gdis_FntCreate(%1,%2,%3,%4,%5,%6,%7,%8,%9,%10,%11,%12,%13,%14)
#define global ctype _BshCreate(%1=0,%2=0,%3=0)                                Gdis_BshCreate(%1,%2,%3)
#define global ctype _PenCreate(%1=0,%2=0,%3=0,%4=-1,%5=0,%6=0)                Gdis_PenCreate(%1,%2,%3,%4,%5,%6)
#define global ctype _BmaCreate(%1=32,%2=32,%3=0,%4=0,%5=0)                    Gdis_BmaCreate(%1,%2,%3,%4,%5)
#define global ctype _GetStruct(%1=0,%2=_Ures@Func)                            Gdis_GetStruct(%1,%2)
#define global       _Pstyle(%1=0,%2=0,%3=1,%4=-1,%5=0,%6=0,%7=15)           __DeleteObject _hPen(%7)  :_Hbms@Func(37) = Gdis_PenCreate(%1,%3,%2,%4,%5,%6) :_hPen(%7) = stat
#define global       _Bstyle(%1=0,%2=0,%3=2,%4=15)                           __DeleteObject _hBsh(%4)  :_Hbms@Func(36) = Gdis_BshCreate(%3,%1,%2)          :_hBsh(%4) = stat
#define global       _Fstyle(%1=msmincho,%2=13,%3=0,%4=0,%5=0,%6=400,%7=0,%8=0,%9=0,%10=128,%11=0,%12=0,%13=2,%14=49,%15=15) \
                                                                             __DeleteObject _hFnt(%15) :__SelectObject hdc,Gdis_FntCreate(%1,%2,%3,%4,%5,%6,%7,%8,%9,%10,%11,%12,%13,%14) :_hFnt(%15) = stat
;|========.===========================.============[                    ]=====|
#define global ctype _IcoExtr(%1="shell32.dll",%2=0,%3=1)                      Gdis_IcoExtr(%1,%2,%3)
#define global ctype _IcoPath(%1="",%2=0)                                      Gdis_IcoPath(%1,%2)
#define global ctype _ImgLoad(%1="rc/UhspObjs.bmp",%2=16)                      Gdis_ImgLoad(%1,%2)
#define global       _BmpDraw(%1=0,%2=0,%3=0,%4=0)                             Gdis_BmpDraw %1,%2,%3,%4
#define global       _IcoDraw(%1=0,%2=0,%3=0,%4=0,%5=0,%6=0,%7=0,%8=0,%9=3)    Gdis_IcoDraw  %1,%2,%3,%4,%5,%6,%7,%8,%9
;|============================================================================|
#global
#endif
