;|=================================================[  UhspMenu.as       ]=====|
#ifndef        __UHSP_MENU__
#define global __UHSP_MENU__
#ifndef        __UHSP_FUNC__
#include "UhspFunc.as"
#endif
;|========.===========================.============[                    ]=====|
#enum   global  _MENU_ADD         =  0
#enum   global  _MENU_SEPARETER
#enum   global  _PMEN_ADD
#enum   global  _MENU_INSERT
#enum   global  _MENU_DELETE
#enum   global  _MENU_CHANGE
#enum   global  _MENU_RADIO
#enum   global  _MENU_CHECK
#enum   global  _MENU_ENABLE
#enum   global  _MENU_HILIGHT
#enum   global  _MENU_BOLD
#enum   global  _MENU_BITMAP
#enum   global  _MENU_BITMAP2
#enum   global  _MENU_STATE
#enum   global  _MENU_STATE2
#enum   global  _MENU_SET
#enum   global  _PMEN_SHOW
#enum   global  _MENU_SHOW
#enum   global  _MENU_DISTROY
#enum   global  _MENU_CREATE
#enum   global  _PMEN_CREATE
#enum   global  _MENU_UNSET
#enum   global  _MENU_DRAW
;|========.===========================.============[                    ]=====|
#module   Menu
#deffunc  Menu_MenBar int p1,int p2,int p3,int p4,str p5,int p6,local nn,local rr
                __IsMenu p2     :  rr = stat
 if (rr) {switch  p1
            case _MENU_ADD      :__AppendMenuA         p2,p3     ,p4,p5       :swbreak ; add
            case _MENU_SEPARETER:__AppendMenuA         p2,p3|$800,p4,p5       :swbreak ; separeter
            case _PMEN_ADD      :__AppendMenuA         p2,p3|$10 ,p4,p5       :swbreak ; addpopup
            case _MENU_INSERT   :__InsertMenuA         p2,p3,  p6,p4,p5       :swbreak ; insert
            case _MENU_DELETE   :__DeleteMenu          p2,p4,  p6             :swbreak ; delete
            case _MENU_RADIO    :__CheckMenuRadioItem  p2,_LoWord(p3),_HiWord(p3),p4,$100
                                                                              :swbreak ; radio
            case _MENU_CHECK    :__CheckMenuItem       p2,p4,p3|$8            :swbreak ; check
            case _MENU_ENABLE   :__EnableMenuItem      p2,p4,p3               :swbreak ; enable
            case _MENU_HILIGHT  :__HiliteMenuItem hwnd,p2,p4,p3|$80           :swbreak ; hilight
            case _MENU_BOLD     :__SetMenuDefaultItem  p2,p4,p6               :swbreak ; bold
            case _MENU_BITMAP   :__SetMenuItemBitmaps  p2,p4,p6 ,p3,int(p5)   :swbreak ; bitmap
            case _MENU_BITMAP2  :  nn = 48,$80,0,0,0,0,0,0,0,0,0,p3,int(p5)
                                 __SetMenuItemInfoA    p2,p4,p6,varptr(nn)    :swbreak ; bitmap
            case _MENU_STATE    :  nn = 48,$1 ,0,p3,0,0,0,0,0,0,0,0,0
                                 __SetMenuItemInfoA    p2,p4,p6,varptr(nn)    :swbreak ; state
            case _MENU_CHANGE   : _Hstr@Func = p5
                                   nn = 48,$40,0,0,0,0,0,0,0,varptr(_Hstr@Func),0,0,0
                                 __SetMenuItemInfoA    p2,p4,p6,varptr(nn)    :swbreak ; chenge
            case _MENU_SET      :__SetMenu        hwnd,p2                     :swbreak ; setmenu
            case _PMEN_SHOW     : if (p3 == -1) or (p4 == -1) {nn = ginfo(0),ginfo(1)}
                                else                          {nn = p3,p4}
                                 __TrackPopupMenu      p2,$100,nn,nn(1),0,hwnd,0
                                                                              :swbreak ; popup
            case _MENU_SHOW     :__SetMenu        hwnd,p2 :__DrawMenuBar  hwnd:swbreak ; setmenu+draw
            case _MENU_DISTROY  :__DestroyMenu         p2                     :swbreak ; destroy
            case _MENU_STATE2   :  nn = 48,p3|$41,0,0,0,0,0,0,0,varptr(_Hstr@Func),512,0,0
                                 __GetMenuItemInfoA    p2,p4,p6,varptr(nn)
                                  _Hint@Func =  nn(3)                         :swbreak ; state2
            default             : _Hint@Func = -1                             :swbreak
          swend}
 else    {switch  p1
            case _MENU_CREATE   :__CreateMenu                                 :swbreak ; create
            case _PMEN_CREATE   :__CreatePopupMenu                            :swbreak ; createpopup
            case _MENU_UNSET    :__SetMenu        hwnd,0                      :swbreak ; unsetmenu
            case _MENU_DRAW     :__DrawMenuBar    hwnd                        :swbreak ; redraw
            default             : _Hint@Func = -1                             :swbreak
          swend}                :  rr =  stat
return  rr
;|========.===========================.============[                    ]=====|
#undef               _MenBar
#define global       _MenBar(%1=0,%2=0,%3=0,%4=0,%5="",%6=0)            Menu_MenBar %1,%2,%3,%4,%5,%6
;|============================================================================|
#global
#endif
