;|=================================================[  UhspSend.as       ]=====|
#ifndef        __UHSP_SEND__
#define global __UHSP_SEND__
#ifndef        __UHSP_FUNC__
#include "UhspFunc.as"
#endif
;|========.===========================.============[                    ]=====|
#module   Send
;|========.===========================.============[                    ]=====|
#define         _BUTN             "Button" 
#define         _MESB             "Edit"
#define         _COMB             "ComboBox"
#define         _LSTB             "ListBox"
#define         _LABL             "Static"
#define         _UPDN             "msctls_updown32"
#define         _PRGB             "msctls_progress32"
#define         _TRKB             "msctls_trackbar32"
#define         _STAB             "msctls_statusbar32"
#define         _TOLB             "ToolbarWindow32"
#define         _REBC             "ReBarWindow32"
#define         _PAGC             "SysPager"
#define         _TABC             "SysTabControl32"
#define         _CALC             "SysMonthCal32"
#define         _DATC             "SysDateTimePick32"
#define         _SCRB             "ScrollBar"
#define         _TREV             "SysTreeView32"
#define         _LSTV             "SysListView32"
#define         _TIPS             "tooltips_class32"
#define         _RICH             "RICHEDIT"
#define         _ATXO             "AtlAxWin71"
;|========.===========================.============[                    ]=====|
#enum   global  _VALUE            =  1
#enum   global  _ADD
#enum   global  _LENGTH
#enum   global  _DELETE
#enum   global  _CHANGE
#enum   global  _COLOR
#enum   global  _MODIFY
#enum   global  _BITMAP
#enum   global  _ICON
#enum   global  _IMAGE
#enum   global  _FONT                 ;_TEXT  =  0,_HEIGHT  = 13
;|========.===========================.============[                    ]=====|
#defcfunc Send_Rsend int p1,int p2,int p3,int p4,str p5,int p6,int p7,local rr,local nn,local ss
     sdim ss,512,3 :dim nn,16:__GetClassNameA  p2,varptr(ss),512 :mref _Hbms@Func,67
   switch p1
          case _TEXT
                switch ss
                  case _BUTN :__GetWindowTextA p2,varptr(ss(1)),512
                                                         :rr    =  ss(1)       :swbreak
                  case _LSTB                             :nn    =  p3
                             :  if (p3 == _NULL) {sendmsg p2,$188  :nn    =  stat}      ;LB_GETCURSEL
                             :  sendmsg p2,$189,nn,varptr(ss(1))                        ;LB_GETTEXT (sendmsg hwnd,$D,260,varptr(ss))
                                                         :rr    =  ss(1)       :swbreak
                  case _COMB                             :nn    =  p3
                             :  if (p3 == _NULL) {sendmsg p2,$147  :nn    =  stat}      ;CB_GETCURSEL
                             :  sendmsg p2,$148,nn,varptr(ss(1))                        ;CB_GETLBTEXT
                                                         :rr    =  ss(1)       :swbreak
                  case _RICH
                  case _MESB :  switch p4
                                  case -1 :sendmsg p2,$0B0,varptr(nn(2)),varptr(nn(3))  ;EM_GETSEL
                                           sendmsg p2,$0B1,p3,p3                        ;EM_SETSEL
                                        sendmsg p2,$0C9,-1:nn    =  stat                ;EM_LINEFROMCHAR
                                  await:sendmsg p2,$0C1,nn:nn(1) =  stat+16             ;EM_LINELENGTH
                                           sdim rr,nn(1)  :wpoke rr,,nn(1)
                                           sendmsg p2,$0C4,nn,varptr(rr)                ;EM_GETLINE
                                           sendmsg p2,$0B0,varptr(nn)                   ;EM_GETSEL
                                           sendmsg p2,$0B1,nn(2),nn(3)    :swbreak      ;EM_SETSEL
                                  default :               :nn    =  p3
                                         if (p3 == _NULL) {sendmsg p2,$0C9,-1           ;EM_LINEFROMCHAR
                                                          :nn    =  stat}
                                  await:sendmsg p2,$0C1,nn:nn(1) =  stat                ;EM_LINELENGTH
                                           sdim rr,nn(1)  :wpoke rr,,nn(1)+16
                                           sendmsg p2,$0C4,nn,varptr(rr)                ;EM_GETLINE
                                           sendmsg p2,$0B0,varptr(nn)     :swbreak      ;EM_GETSEL
                                swend                                          :swbreak
                  case _LABL :  sendmsg p2,$00D,512,varptr(ss(1))                       ;SS_OWNERDRAW
                                                          :rr    =  ss(1)      :swbreak
                  case _STAB                              :nn    =  p3
                                if (p3 == _NULL)          {nn    =  0}
                             :  sendmsg p2,$402,nn,varptr(ss(1))                        ;SB_GETTEXTA
                                                          :rr    =  ss(1)      :swbreak
                  case _TABC                              :rr    =  p3
                             :  if (p3 == _NULL) {sendmsg p2,$130B :rr    =  stat}      ;TCM_GETCURSEL
                                nn    =  $3,0,0,varptr(ss(1)),512
                                sendmsg p2,$1305,rr,varptr(nn)                          ;TCM_GETITEMA
                                                          :rr    =  ss(1)      :swbreak
                  case _TIPS :  nn    = 40,$10,p3,0,0,0,0,0,0,varptr(ss(1))
                                sendmsg p2,$40B,0,varptr(nn)                            ;TTM_GETTEXTA
                                                          :rr    =  ss(1)      :swbreak
                  case _LSTV :  nn    = $1,0,p3,0,0,varptr(ss(1)),512
                                sendmsg p2,$102D,p4,varptr(nn)                          ;LVM_GETITEMTEXTA
                                                          :rr    =  ss(1)      :swbreak
                  case _TREV :  nn    = $F,p3,0,0  ,varptr(ss(1)),512
                             :  sendmsg p2,$110C,0 ,varptr(nn)                          ;TVM_GETITEMA
                                                          :rr    =  ss(1)      :swbreak
                  default    :__GetWindowTextA  p2 ,varptr(ss(1)),512
                                                          :rr    =  ss(1)      :swbreak
                swend                                                          :swbreak
          case _VALUE
                switch ss
                  case _BUTN :  sendmsg p2,$F0            :rr    =  stat       :swbreak ;BM_GETCHECK
                  case _LSTB :  switch p4
                                  case -1 :               :ss(1) =  p5
                                         if (p3   >=   0) {sendmsg p2,$01A2,-1,varptr(ss(1))} ;LB_FINDSTRINGEXACT
                                         else             {sendmsg p2,$018F,-1,varptr(ss(1))} ;LB_FINDSTRING
                                                          :rr    =  stat :swbreak
                                  default :__GetWindowLongA p2,-16
                                         if (stat &    8) {sendmsg p2,$187,p3}          ;LB_GETSEL
                                       else               {sendmsg p2,$188   }          ;LB_GETCURSEL
                                                          :rr    =  stat :swbreak
                                swend                                          :swbreak
                  case _COMB :  switch p4
                                  case -1 :               :ss(1) =  p5
                                         if (p3   >=   0) {sendmsg p2,$0158,-1,varptr(ss(1))} ;CB_FINDSTRINGEXACT
                                         else             {sendmsg p2,$014C,-1,varptr(ss(1))} ;CB_FINDSTRING
                                                          :rr    =  stat :swbreak
                                  case -2 :               :ss(1) =  p5
                                           sendmsg p2,$14D,,varptr(ss(1))               ;CB_SELECTSTRING
                                                          :rr    =  stat :swbreak
                                  default :sendmsg p2,$147:rr    =  stat       :swbreak ;CB_GETCURSEL
                                swend                                          :swbreak
                  case _RICH
                  case _MESB :  switch p4
                                  case -1 :sendmsg p2,$0B0,varptr(nn(2)),varptr(nn(3))  ;EM_GETSEL
                                           sendmsg p2,$0B1,p3,p3                        ;EM_SETSEL
                                           sendmsg p2,$0C9,-1                           ;EM_LINEFROMCHAR
                                                          :rr    =  stat
                                           sendmsg p2,$0B1,nn(2),nn(3)    :swbreak      ;EM_SETSEL
                                  case -2 :sendmsg p2,$0B0,varptr(nn(2)),varptr(nn(3))  ;EM_GETSEL
                                          :rr    = _MakeLong(nn(2),nn(3)) :swbreak
                                  case -3 :sendmsg p2,$00E:rr    =  stat  :swbreak      ;WM_GETTEXTLENGTH
                                  case -4 :sendmsg p2,$0D5:rr    =  stat  :swbreak      ;EM_GETLIMITTEXT
                                  case -5 :sendmsg p2,$0CE:rr    =  stat  :swbreak      ;EM_GETFIRSTVISIBLELINE
                                  default :sendmsg p2,$0C9,-1                           ;EM_LINEFROMCHAR
                                                          :rr    =  stat  :swbreak
                                swend                                          :swbreak
                  case _UPDN :  sendmsg p2,$472           :rr    =  stat       :swbreak ;UDM_GETPOS32
                  case _PRGB :  sendmsg p2,$408           :rr    =  stat       :swbreak ;PBM_GETPOS
                  case _TRKB :  sendmsg p2,$400           :rr    =  stat       :swbreak ;TBM_GETPOS
                  case _TABC :  sendmsg p2,$130B          :rr    =  stat       :swbreak ;TCM_GETCURSEL
                  case _CALC :                            :sendmsg p2,$1001,,varptr(nn) ;MCM_GETCURSEL
                             :  rr  = strf("%d,%02d,%02d" ,wpeek(nn, 0),wpeek(nn, 2),wpeek(nn, 6))
                                                                               :swbreak
                  case _DATC :                            :sendmsg p2,$1001,,varptr(nn) ;MCM_GETCURSEL
                             :  rr  = strf("%d,%02d,%02d,",wpeek(nn, 0),wpeek(nn, 2),wpeek(nn, 6))
                             :  rr += strf("%d,%02d,%02d" ,wpeek(nn, 8),wpeek(nn,10),wpeek(nn,12))
                                                                               :swbreak
                  case _SCRB :  nn  = 28,31,0,0,0,0,0     :__GetScrollInfo p2,2,varptr(nn)
                                                          :rr    =  nn(6)      :swbreak
                  case _TIPS :  if (p4 <=  0) {rr =  2} else {rr =  3}
                                sendmsg p2,$415,rr        :rr    =  stat       :swbreak ;TTM_GETDELAYTIME
                  case _LSTV :  switch p4
                                  case -1 :rr    = -1     :nn    =  $8,p3,0,0,2,0
                                          :sendmsg p2,$1005,0,varptr(nn)                ;LVM_GETITEMA
                                       if (nn(3)      )   {rr    = nn(1)}:swbreak
                                  case -2 :sendmsg p2,$1004                             ;LVM_GETITEMCOUNT
                                                          :rr    =  stat :swbreak
                                  case -3 :sendmsg p2,$102C,p3,$F000                    ;LVM_GETITEMSTATE
                                          :rr    = ((stat/4096)-1)       :swbreak
                                  case -4 :sendmsg p2,$101D,p3                          ;LVM_GETCOLUMNWIDTH
                                                          :rr    =  stat :swbreak
                                  case -5 :sendmsg p2,$101F                             ;LVM_GETHEADER
                                                          :rr    =  stat :swbreak       ;LVM_GETHEADER
                                  default :sendmsg p2,$100C,-1,$0002                    ;LVM_GETNEXTITEM
                                                          :rr    =  stat :swbreak
                                swend                                    :swbreak
                  case _TREV :  switch p4
                                  case -2 :sendmsg p2,$1105                             ;TVM_GETCOUNT
                                                          :rr    =  stat :swbreak
                                  case -3 :nn    = $8,p3,0
                                          :sendmsg p2,$110C,0,varptr(nn)                ;TVM_GETITEMA
                                          :rr    =  nn(2)>>12            :swbreak
                                  case -4 :sendmsg p2,$110A,0,p3                        ;TVM_GETNEXTITEM
                                                          :rr    =  stat :swbreak
                                  case -5 :sendmsg p2,$110A,1,p3                        ;TVM_GETNEXTITEM
                                                          :rr    =  stat :swbreak
                                  case -6 :sendmsg p2,$110A,4,p3                        ;TVM_GETNEXTITEM
                                                          :rr    =  stat :swbreak
                                  case -7 :sendmsg p2,$110A,2,p3                        ;TVM_GETNEXTITEM
                                                          :rr    =  stat :swbreak
                                  default :sendmsg p2,$110A,9                           ;TVM_GETNEXTITEM
                                                          :rr    =  stat :swbreak
                                swend                                    :swbreak
                   default    :                           :rr    = -1          :swbreak
                 swend                                                         :swbreak
          case _ADD                                                            :swbreak
          case _LENGTH
                switch ss
                  case _LSTB :  sendmsg p2,$18B           :rr    =  stat       :swbreak ;LB_GETCOUNT
                  case _COMB :  sendmsg p2,$146           :rr    =  stat       :swbreak ;CB_GETCOUNT
                  case _RICH
                  case _MESB :  switch p4
                                  case -1 :sendmsg p2,$C1 :swbreak                      ;EM_LINELENGTH
                                  default :sendmsg p2,$BA :swbreak                      ;EM_GETLINECOUNT
                                swend                     :rr    =  stat       :swbreak
                  case _STAB :  sendmsg p2,$406           :rr    =  stat       :swbreak ;SB_GETPARTS
                  case _UPDN :  sendmsg p2,$466           :rr    =  stat       :swbreak ;UDM_GETRANGE
                  case _SCRB :  nn    = 28,31,0,0,0,0,0   :__GetScrollInfo p2,2,varptr(nn)
                             :  rr    = _MakeLong(nn(2),nn(3)                  :swbreak
                  case _PRGB :  sendmsg p2,$407,1,0       :nn    =  stat
                                sendmsg p2,$407,0,0       :rr    = _MakeLong(nn,stat)   ;PBM_GETRANGE
                                                                               :swbreak
                  case _TRKB :  sendmsg p2,$401           :nn    =  stat                ;TBM_GETRANGEMIN
                                sendmsg p2,$402           :rr    = _MakeLong(nn,stat)   ;TBM_GETRANGEMAX
                                                                               :swbreak
                  case _LSTV :  sendmsg p2,$101F          :rr    =  stat                ;LVM_GETHEADER
                                sendmsg rr,$1200          :rr    =  stat       :swbreak ;HDM_GETITEMCOUNT
                  default    :                            :rr    = -1          :swbreak
                swend                                                          :swbreak
          case _DELETE                                                         :swbreak
          case _CHANGE                                                         :swbreak
          case _COLOR                                                          :swbreak
          case _MODIFY
                switch ss
                  case _LSTB :  switch p4
                                  case -1 :sendmsg p2,$18E:rr    =  stat :swbreak       ;LB_GETTOPINDEX
                                  case -2 :sendmsg p2,$193:rr    =  stat :swbreak       ;LB_GETHORIZONTALEXTENT
                                  default :               :rr    = -1    :swbreak
                                swend                                          :swbreak
                  case _COMB :  switch p4
                                  case -1 :sendmsg p2,$15D:rr    =  stat :swbreak       ;CB_GETHORIZONTALEXTENT
                                  case -2 :sendmsg p2,$157:rr    =  stat :swbreak       ;CB_GETDROPPEDSTATE
                                  default :               :rr    = -1    :swbreak
                                swend                                          :swbreak
                  case _RICH
                  case _MESB :  switch p4
                                  case -1 :sendmsg p2,$0B7:rr    =  stat :swbreak       ;EM_SCROLLCARET
                                  case -8 :sendmsg p2,$0B8:rr    =  stat :swbreak       ;EM_GETMODIFY
                                  default :sendmsg p2,$0D2:rr    =  stat :swbreak       ;EM_GETPASSWORDCHAR
                                swend                                          :swbreak
                  default    :                            :rr    = -1          :swbreak
                swend                                                          :swbreak
          case _BITMAP                                                         :swbreak
          case _ICON         :__GetClassLongA p2,-14      :rr    =  stat       :swbreak ;GCL_HICON,GCL_HICONSM(-34)
          case _IMAGE                                                          :swbreak
          case _FONT         :  sendmsg p2,$031           :rr    =  stat       :swbreak
          case _HEIGHT
                switch ss
                  case _LSTB :  sendmsg p2,$1A1,0,0       :rr    =  stat       :swbreak ;LB_GETITEMHEIGHT
                  case _COMB :  sendmsg p2,$154,0,0       :rr    =  stat       :swbreak ;CB_GETITEMHEIGHT
                  case _RICH
                  case _MESB :  if (p4 == _NULL) {
                                    sendmsg p2,$0D4       :rr    =  stat}               ;EM_GETMARGINS
                              else {sendmsg p2,$0B2,,varptr(nn)                         ;EM_GETRECT
                                                          :rr    =  varptr(nn)}:swbreak
                  default    :                            :rr    = -1          :swbreak
                swend                                                          :swbreak
          default :                                       :rr    = -1          :swbreak
   swend          :_Mint@Func = p2
return  rr
;|========.===========================.============[                    ]=====|
#defcfunc Send_Wsend int p1,int p2,int p3,int p4,str p5,int p6,int p7,local rr,local nn,local ss
     sdim ss,512,3:dim nn,16 :__GetClassNameA  p2,varptr(ss),512 :mref _Hbms@Func,67
   switch p1
          case _TEXT
                switch ss
                  case _BUTN                              :ss(1) =  p5
                             :__SetWindowTextA p2,varptr(ss(1))
                                                          :rr    =  stat       :swbreak
                  case _LSTB :  sendmsg p2,$184           :ss(1) =  p5                  ;LB_RESETCONTENT
                                notesel ss(1)
                                repeat notemax            :noteget ss(2),cnt
                                       await :sendmsg p2,$180,0,varptr(ss(2))           ;LB_ADDSTRING
                                loop         :noteunsel   :sendmsg p2,$186,p3           ;LB_SETCURSEL
                                                          :rr    =  ss(1)      :swbreak
                  case _COMB :  sendmsg p2,$14B           :ss(1) =  p5                  ;CB_RESETCONTENT
                                notesel ss(1)
                                repeat notemax            :noteget ss(2),cnt
                                       await :sendmsg p2,$143,0,varptr(ss(2))           ;CB_ADDSTRING
                                loop         :noteunsel   :sendmsg p2,$14E,p3           ;CB_SETCURSEL
                  case _RICH
                  case _MESB                              :ss(1) = p5
                             :  sendmsg p2,$C,0,varptr(ss(1))                           ;WM_SETTEXT
                                sendmsg p2,$0BB,p3        :nn    =  stat                ;EM_LINEINDEX
                                sendmsg p2,$0BB,p3        :sendmsg p2,$0B1,nn,stat      ;EM_SETSEL
                                                          :rr    =  stat       :swbreak
                  case _LABL :  sendmsg p2,$00C,0,p5      :rr    =  stat       :swbreak ;SS_LEFTNOWORDWRAP
                  case _STAB :  sendmsg p2,$401,limit(p3,0,p3),p5                       ;SB_SETTEXTA
                                                          :rr    =  stat       :swbreak
                  case _TOLB                              :ss(1) =  p5
                                                          :rr    =  strlen@hsp(ss(1))
                             :  ss(1) = Func_Rchr(ss(1),'|',0,_Ustr@Func)
                                memcpy  ss(1),_Ustr@Func,rr
                                if (p4 == _NULL) {__GetWindowLongA p2,-16
                                                  __SetWindowLongA p2,-16,stat | $1100
                                                          :sendmsg p2,$454,0,$8}        ;TB_SETEXTENDEDSTYLE
                                sendmsg p2,$41C,0,varptr(ss(1))                         ;TB_ADDSTRINGA
                                if (p4 != _NULL) {sendmsg p2,$421,0,0}                  ;TB_AUTOSIZE
                                                          :rr    =  stat       :swbreak
                  case _TREV :                            :ss(1) =  p5
                             :  nn   = 0,0,$23,p3,0,0,varptr(ss(1)),1
                                sendmsg p2,$110D,0,varptr(nn)+8                         ;TVM_SETITEMA
                                                          :rr    =  stat       :swbreak
                  default    :                            :ss(1) = p5
                             :__SetWindowTextA  p2,varptr(ss(1))
                                                          :rr    =  stat       :swbreak
                swend                                                          :swbreak
          case  _VALUE
                switch ss
                  case _BUTN :  sendmsg p2,$F1,p3         :rr    =  stat       :swbreak ;BM_SETCHECK
                  case _LSTB :__GetWindowLongA p2,-16
                                if (stat &    8) {sendmsg p2,$185,1,p3}                 ;LB_SETSEL
                              else               {sendmsg p2,$186,p3  }                 ;LB_SETCURSEL
                                                          :rr    =  stat       :swbreak
                  case _COMB                              :nn    =  p3
                             :  sendmsg p2,$14E,p3        :rr    =  stat       :swbreak ;CB_SETCURSEL
                  case _RICH
                  case _MESB :  switch p4
                                  case -1 :sendmsg p2,$0B1,p3,p3                        ;EM_SETSEL
                                                          :rr    =  stat    :swbreak
                                  case -2 :sendmsg p2,$0B1,p3,p6                        ;EM_SETSEL
                                                          :rr    =  stat    :swbreak
                                  case -3 :sendmsg p2,$00E:rr    =  stat                ;WM_GETTEXTLENGTH
                                           sdim nn,rr+1
                                           sendmsg p2,$00D,rr+1,varptr(nn)              ;WM_GETTEXT
                                           notesel nn     :rr    =  0
                                           repeat  limit(p3,0,p3)  :noteget ss(1),cnt
                                                   await  :rr   +=  strlen@hsp(ss(1))+2
                                           loop                    :noteget ss(1),limit(p3,0,p3)
                                                                   :noteunsel
                                           sendmsg p2,$0B1,rr+strlen@hsp(ss(1)),rr      ;EM_SETSEL
                                                                            :swbreak
                                  case -4 :sendmsg p2,$0C5,p3                           ;EM_LIMITTEXT
                                                          :rr    =  stat    :swbreak
                                  default :sendmsg p2,$00E:rr    =  stat                ;WM_GETTEXTLENGTH
                                           sdim nn,rr+1
                                           sendmsg p2,$00D,rr+1,varptr(nn)              ;WM_GETTEXT
                                           notesel nn     :rr    =  0
                                           repeat  limit(p3,0,p3)  :noteget ss(1),cnt
                                                   await  :rr   +=  strlen@hsp(ss(1))+2
                                           loop           :noteunsel
                                           sendmsg p2,$0B1,rr,rr            :swbreak    ;EM_SETSEL
                                swend                                          :swbreak
                  case _TOLB :  sendmsg p2,$411,p3,1<<p4  :rr    =  stat       :swbreak ;TB_SETSTATE
                  case _UPDN :  sendmsg p2,$467,0,p3      :rr    =  stat       :swbreak ;UDM_SETPOS
                  case _PRGB :  if (p4 <=     0) {sendmsg p2,$402,p3}                   ;PBM_SETPOS
                              else               {sendmsg p2,$403,p3}                   ;PBM_DELTAPOS
                                                          :rr    =  stat       :swbreak
                  case _TRKB :  sendmsg p2,$405,1,p3      :rr    =  stat       :swbreak ;TBM_SETPOS
                  case _TABC :  sendmsg p2,$130C,p3       :rr    =  stat       :swbreak ;TCM_SETCURSEL
                  case _CALC :                            :rr    =  Func_Split(p5+",,,",",",rr,0)
                             :  wpoke nn,0,int(rr)        :wpoke    nn, 2,int(rr(1))
                             :  wpoke nn,6,int(rr(2))     :sendmsg  p2,$1002,,varptr(nn);MCM_SETCURSEL
                                                          :rr    =  stat       :swbreak
                  case _DATC :                            :rr    =  Func_Split(p5+",,,,,,",",",rr,0)
                             :  wpoke nn, 0,int(rr)       :wpoke    nn, 2,int(rr(1))
                             :  wpoke nn, 6,int(rr(2))    :wpoke    nn, 8,int(rr(3))
                             :  wpoke nn,10,int(rr(4))    :wpoke    nn,12,int(rr(5))
                             :  sendmsg p2,$1002,,varptr(nn)                            ;MCM_SETCURSEL
                                                          :rr    =  stat       :swbreak
                  case _SCRB :  nn    = 28,31,0,0,0,0,0
                               _Oint@Func(Func_Hoid(p2),ginfo_sel) = p3
                              __SetScrollPos p2,2,p3,1    :rr    =  stat       :swbreak
                  case _TIPS :  if (p4 <=  0) {rr =  2} else {rr =  3}
                                sendmsg p2,$403,rr,p3     :rr    =  stat       :swbreak ;TTM_SETDELAYTIME
                  case _LSTV :  switch p4
                                  case -3 :nn    = 0,0,0,$2000,$F000
                                          :sendmsg p2,$102B,p3,varptr(nn)               ;LVM_SETITEMSTATE
                                                          :rr    =  stat :swbreak
                                  default :nn    = $3,p3,0,$3,3
                                          :sendmsg p2,$102B,p3,varptr(nn)               ;LVM_SETITEMSTATE
                              :__SetFocus p2              :rr    =  stat :swbreak
                                 swend                                   :swbreak
                  case _TREV :  switch p4
                                  case -3 :nn    = $8,p3,$2000,$F000
                                          :sendmsg p2,$110D,0,varptr(nn) :swbreak       ;TVM_SETITEMA
                                  default :sendmsg p2,$110B,9,p3                        ;TVM_SELECTITEM
                              :__SetFocus p2              :rr    =  stat :swbreak
                                 swend                                   :swbreak
                  default     :                           :rr    = -1          :swbreak
                swend                                                          :swbreak
          case _ADD
                switch ss
                  case _LSTB                              :ss(1) =  p5
                             :  if (p3 == _NULL) {sendmsg p2,$180,  ,varptr(ss(1))}     ;LB_ADDSTRING
                              else               {sendmsg p2,$181,p3,varptr(ss(1))}     ;LB_INSERTSTRING
                                                          :rr    =  stat       :swbreak
                  case _COMB                              :ss(1) =  p5
                             :  if (p3 == _NULL) {sendmsg p2,$143,  ,varptr(ss(1))}     ;CB_ADDSTRING
                              else               {sendmsg p2,$14A,p3,varptr(ss(1))}     ;CB_INSERTSTRING
                                                          :rr    =  stat       :swbreak
                  case _RICH
                  case _MESB :  sendmsg p2,$00E           :rr    =  stat
                                   sdim nn,rr+1           :sendmsg p2,$00D,rr+1,varptr(nn) ;WM_GETTEXT
                                if (p3  >    -1) { rr = 0 :notesel nn
                                           repeat  p3     :noteget ss(1),cnt
                                                   await  :rr   +=  strlen@hsp(ss(1))+2
                                           loop           :noteunsel}
                                sendmsg p2,$0B1,rr,rr     :ss(1) =  p5                  ;EM_SETSEL
                                sendmsg p2,$0C2,0,varptr(ss(1))                :swbreak ;EM_REPLACESEL
                  case _REBC                              :ss(1) =  p5
                             :  nn    =  80,$75,p4,0,0,varptr(ss(1)),0,0
                                nn(8) =  p3,p6,_Hbms@Func(30),_Hbms@Func(29)
                                sendmsg  p2,$401,-1,varptr(nn)                          ;RB_INSERTBAND
                                                          :rr    =  stat       :swbreak
                  case _PAGC
                             :__SetWindowLongA p3,-8,p2
                                sendmsg  p2,$1401,0,p3    :rr    =  stat       :swbreak ;PGM_SETCHILD
                             
                  case _TABC                              :ss(1) =  p5
                             :  nn    =  $3,0,0,varptr(ss(1)),0,limit(p4,0,p4)
                                sendmsg  p2,$1307,limit(p3,0,p3),varptr(nn)             ;TCM_INSERTITEMA
                                                          :rr    =  stat       :swbreak
                  case _TIPS                              :ss(1) =  p5 :dim nn,16
                             :  if (p4 <=  0) {rr =  0} else {rr =  2}
                              __GetClientRect p3,varptr(nn)
                                nn(6) = nn(2)-nn,nn(3)-nn(1),0,varptr(ss(1))
                                nn    = 40,($10 | rr),p3,0,0,0
                                sendmsg p2,$404,,varptr(nn)                             ;TTM_ADDTOOLA
                                                          :rr    =  stat       :swbreak
                  case _LSTV :                            :ss(1) =  p5
                    if (p6 ==  0) {nn    = $3,p3, 0,0,0,varptr(ss(1)),0,p7
                                  :sendmsg p2,$1007,   ,varptr(nn)}                     ;LVM_INSERTITEMA
                  else            {nn    = $3,p3,p6,0,0,varptr(ss(1)),0,p7
                                  :sendmsg p2,$1006,   ,varptr(nn)}                     ;LVM_SETITEMA
                                                          :rr    =  stat       :swbreak
                  case _TREV :                            :ss(1) =  p5
                             :  if (p4 ==     1) {nn    = p3,$FFFF0001}
                         else:  if (p4 ==     2) {nn    = p3,$FFFF0002}
                         else:  if (p4 ==     3) {nn    = p3,$FFFF0003}
                         else                    {nn    = p3,$FFFF0000}
                                if (p3 == _NULL) {nn    =  0,$FFFF0000}
                                                 :nn(2) = $23,0,0,0,varptr(ss(1)),0,p6,p7
                           sendmsg p2,$1100,0,varptr(nn)  :rr    =  stat       :swbreak ;TVM_INSERTITEMA
                  default    :                            :rr    = -1          :swbreak
                swend                                                          :swbreak
          case _LENGTH
                switch ss
                  case _STAB : _Uany@Func = ss            :ss    =  p5
                             :  split ss,",",ss           :rr    =  length(ss)
                             :  dim nn,rr :repeat rr      :nn(cnt) = int(ss(cnt))
                                await     :loop           :ss    = _Uany@Func
                                sendmsg p2,$404,rr,varptr(nn)                  :swbreak ;SB_SETPARTS
                  case _UPDN :  sendmsg p2,$465,,p3       :rr    = -1          :swbreak ;UDM_SETRANGE
                  case _SCRB :  nn    = 28,31,_LoWord(p3),_HiWord(p3),0,0,0
                             :__SetScrollInfo p2,2, varptr(nn),1
                                                          :rr    =  stat       :swbreak
                  case _PRGB :  sendmsg p2,$401,,p3       :rr    = -1          :swbreak ;PBM_SETRANGE
                  case _TRKB :  sendmsg p2,$407,,_LoWord(p3)                            ;TBM_SETRANGEMIN
                                sendmsg p2,$408,,_HiWord(p3)                            ;TBM_SETRANGEMAX
                                                          :rr    =  stat       :swbreak
                  case _LSTV :                            :ss(1) =  p5
                             :  nn    = $F,p3,p4,varptr(ss(1)),0,0,0,p7
                             :  sendmsg p2,$101D,p3,0                                   ;LVM_GETCOLUMNWIDTH
                                if (stat ==   0) {sendmsg p2,$101B,p3,varptr(nn)}       ;LVM_INSERTCOLUMNA
                              else               {sendmsg p2,$101A,p3,varptr(nn)}       ;LVM_SETCOLUMNA
                                                          :rr    =  stat       :swbreak
                  default    :                            :rr    = -1          :swbreak
                swend                                                          :swbreak
          case _DELETE
                switch ss
                  case _LSTB :  sendmsg p2,$182,p3        :rr    =  stat       :swbreak ;LB_DELETESTRING
                  case _COMB :  sendmsg p2,$144,p3        :rr    =  stat       :swbreak ;CB_DELETESTRING
                  case _RICH :
                  case _MESB :  sendmsg p2,$00E           :rr    =  stat                ;WM_GETTEXTLENGTH
                                   sdim nn,rr+1           :sendmsg p2,$00D,rr+1,varptr(nn) ;WM_GETTEXT
                                notesel nn                :rr    =  0
                                           repeat  limit(p3,0,p3)  :noteget ss(1),cnt
                                                   await  :rr   +=  strlen@hsp(ss(1))+2
                                           loop           :noteunsel
                                sendmsg p2,$0B1,rr,rr+strlen@hsp(ss(1))+2               ;EM_SETSEL
                                sendmsg p2,$0C2,0,varptr(ss(2))                :swbreak ;EM_REPLACESEL
                  case _LSTV :  if (p3 == _NULL) {sendmsg p2,$1009, 0}                  ;LVM_DELETEALLITEMS
                              else               {sendmsg p2,$1008,p3}                  ;LVM_DELETEITEM
                                                          :rr    =  stat       :swbreak
                  case _TREV :  if (p3 == _NULL) {sendmsg p2,$1101,0,$FFFF0000}         ;TVM_DELETEITEM
                              else               {sendmsg p2,$1101,0,p3}                ;TVM_DELETEITEM
                                                          :rr    =  stat       :swbreak
                  default    :                            :rr    = -1          :swbreak
                swend                                                          :swbreak
          case _CHANGE
                switch ss
                  case _LSTB :  sendmsg p2,$182,p3        :ss(1) =  p5                  ;LB_DELETESTRING
                                sendmsg p2,$181,p3,varptr(ss(1))                        ;LB_INSERTSTRING
                                                          :rr    =  stat       :swbreak
                  case _COMB :  sendmsg p2,$144,p3        :ss(1) =  p5                  ;CB_DELETESTRING
                                sendmsg p2,$14A,p3,varptr(ss(1))                        ;CB_INSERTSTRING
                                                          :rr    =  stat       :swbreak
                  case _MESB :                            :ss(1) =  p5
                                sendmsg p2,$0C2,0,varptr(ss(1))                         ;EM_REPLACESEL
                                                          :rr    =  stat       :swbreak
                  case _TIPS :                            :ss(1) = p5
                             :  nn    = 40,$10,p3,0,0,0,0,0,0,varptr(ss(1))
                                sendmsg p2,$40C,0,varptr(nn)                            ;TTM_UPDATETIPTEXTA
                                                          :rr    =  stat       :swbreak
                  case _TABC                              :ss(1) =  p5
                             :  nn    = $3,0,0,varptr(ss(1)),512,p4
                                sendmsg p2,$1306,p3,varptr(nn)                          ;TCM_SETITEMA
                                                          :rr    =  stat       :swbreak
                  case _LSTV :                            :rr    =  ""
                             :  dupptr nn,p3,64
                             :  sendmsg p2,$1006,0,varptr(nn)+12                        ;LVM_SETITEMA
                                if (nn(8)      ) {dupptr rr,nn(8),512,2}       :swbreak
                  case _TREV :                            :rr    =  ""
                             :  dupptr nn,p3,64
                                sendmsg p2,$110D,0,varptr(nn)+12                        ;TVM_SETITEMA
                                if (nn(7)      ) {dupptr rr,nn(7),512,2}       :swbreak
                                                          :rr    =  stat       :swbreak
                  default    :                            :rr    = -1          :swbreak
                swend                                                          :swbreak
          case _COLOR
                switch ss
                  case _PRGB :  if (p4    <=  0) {sendmsg p2,$409 ,0,p3}                ;PBM_SETBARCOLOR
                              else               {sendmsg p2,$2001,0,p3}       :swbreak ;PBM_SETBKCOLOR
                                                          :rr    =  stat       :swbreak
                  case _CALC :  sendmsg p2,$100A,p4,p3    :rr    =  stat       :swbreak ;MCM_SETCOLOR
                  case _TIPS :  if (p4    <=  0) {sendmsg p2,$414 ,p3,0}                ;TTM_SETTIPTEXTCOLOR
                              else               {sendmsg p2,$413 ,p3,0}       :swbreak ;TTM_SETTIPBKCOLOR
                                                          :rr    =  stat       :swbreak
                  default    :                            :rr    = -1          :swbreak
                swend                                                          :swbreak
          case _MODIFY
                switch ss
                  case _BUTN :  sendmsg p2,$F5            :rr    =  stat       :swbreak ;BM_CLICK
                  case _LSTB :  switch p4
                                  case -1 :sendmsg p2,$197,p3                           ;LB_SETTOPINDEX
                                                          :rr    =  stat :swbreak
                                  case -2 :sendmsg p2,$194,p3                           ;LB_SETHORIZONTALEXTENT
                                                          :rr    =  stat :swbreak
                                  default :sendmsg p2,$184:ss(1) =  p5                  ;LB_RESETCONTENT
                                           sendmsg p2,$18D,p3,varptr(ss(1))             ;LB_DIR
                                                          :rr    =  stat :swbreak
                                swend                                          :swbreak
                  case _COMB :  switch p4
                                  case -1 :sendmsg p2,$15E,p3                           ;CB_SETHORIZONTALEXTENT
                                                          :rr    =  stat :swbreak
                                  case -2 :sendmsg p2,$014F,p3                          ;CB_SHOWDROPDOWN
                                                          :rr    =  stat :swbreak
                                  default :sendmsg p2,$14B:ss(1) =  p5                  ;CB_RESETCONTENT
                                           sendmsg p2,$145,p3,varptr(ss(1))             ;CB_DIR
                                                          :rr    =  stat :swbreak
                               swend                                           :swbreak
                  case _RICH
                  case _MESB :  switch p4
                                  case -1 :sendmsg p2,$0B1,0,-1
                                                          :rr    =  stat :swbreak       ;EM_SETSEL
                                  case -2 :sendmsg p2,$300:rr    =  stat :swbreak       ;WM_CUT
                                  case -3 :sendmsg p2,$301:rr    =  stat :swbreak       ;WM_COPY
                                  case -4 :sendmsg p2,$302:rr    =  stat :swbreak       ;WM_PASTE
                                  case -5 :sendmsg p2,$303:rr    =  stat :swbreak       ;WM_CLEAR
                                  case -6 :sendmsg p2,$304:rr    =  stat :swbreak       ;WM_UNDO
                                  case -7 :sendmsg p2,$454:rr    =  stat :swbreak       ;EM_REDO
                                  case -8 :sendmsg p2,$0B9,p3                           ;EM_SETMODIFY
                                                          :rr    =  stat :swbreak
                                  case -9 :sendmsg p2,$0CF,p3                           ;EM_SETREADONLY(0,-1)
                                                          :rr    =  stat :swbreak
                                  default :               :nn    =  p3
                                         if (p3 == _NULL) {nn    =  42}
                                        sendmsg p2,$0CC,nn:rr    =  stat                ;EM_SETPASSWORDCHAR
                                         :__RedrawWindow p2,0,0,$401     :swbreak
                                swend                                          :swbreak
                  case _PRGB :  sendmsg p2,$40A,p3,p4     :rr    =  stat       :swbreak ;PBM_SETMARQUEE
                  case _DATC :__GetWindowLongA p2,-16
                             :  if (p4 <=  0) {__SetWindowLongA p2,-16,stat | $4}
                              else            {__SetWindowLongA p2,-16,stat | $9}
                                                          :rr    =  stat       :swbreak
                  case _SCRB :  rr(1) =  Func_Hoid(p2),p4 :if (p4 == _NULL) {rr(2) = 10}
                             :  rr    = _Oint@Func(rr(1),ginfo_sel)
                                nn    = 28,31,0,0,0,0,0   :__GetScrollInfo p2,2,varptr(nn)
                                switch _LoWord(p3)
                                  case  0 :rr --             :swbreak
                                  case  1 :rr ++             :swbreak
                                  case  2 :rr -=  rr(2)      :swbreak
                                  case  3 :rr +=  rr(2)      :swbreak
                                  case  5 :rr  = _HiWord(p3) :swbreak
                                  default :                  :swbreak
                                swend
                            if (rr < nn(2)) {rr = nn(2)}  :if (rr > nn(3)) {rr = nn(3)}
                                    _Oint@Func(rr(1),ginfo_sel)  =  rr
                              __SetScrollPos p2,2,rr,1    :rr    =  stat       :swbreak
                  case _LSTV :  sendmsg  p2,$1036, 0,p3                                 ;LVM_SETEXTENDEDLISTVIEWSTYLE
                             :__SetFocus p2               :rr    =  stat       :swbreak
                  case _TREV :  sendmsg  p2,$1102,limit(p4,1,3),p3                      ;TVM_CREATEDRAGIMAGE
                                                          :rr    =  stat       :swbreak
                  case _TRKB :  sendmsg p2,$414,p3        :rr    =  stat       :swbreak ;TBM_SETTICFREQ
                  case _REBC :  switch p4
                                  case -1 :sendmsg p2,$41E,p3   :rr    =  stat :swbreak ;RB_MINIMIZEBAND
                                  case -2 :sendmsg p2,$41F,p3   :rr    =  stat :swbreak ;RB_MAXIMIZEBAND
                                  case -3 :sendmsg p2,$423,p3,  :rr    =  stat :swbreak ;RB_SHOWBAND
                                  default :sendmsg p2,$423,p3,1 :rr    =  stat :swbreak ;RB_SHOWBAND
                                swend                           :rr    = -1    :swbreak
                  default    :                            :rr    = -1          :swbreak
                swend                                                          :swbreak
          case _BITMAP
                switch ss
                  case _BUTN :  if (p4 == _NULL) {                                      ;BS_BITMAP
                              __GetWindowLongA p2,-16     :__SetWindowLongA p2,-16,stat | $80}
                                sendmsg p2,$0F7,0,p3      :rr    =  stat       :swbreak ;BM_SETIMAGE
                  case _LABL :__GetWindowLongA p2,-16     :__SetWindowLongA p2,-16,stat | $E
                                sendmsg p2,$172,0,p3      :rr    =  stat       :swbreak ;STM_SETIMAGE
                  default    :                            :rr    = -1          :swbreak
                swend                                                          :swbreak
          case _ICON
                switch ss
                  case _BUTN :  if (p4 == _NULL) {                                      ;BS_ICON
                              __GetWindowLongA p2,-16     :__SetWindowLongA p2,-16,stat | $40}
                                sendmsg p2,$0F7,1,p3      :rr    =  stat       :swbreak ;BM_SETIMAGE
                  case _LABL :__GetWindowLongA p2,-16     :__SetWindowLongA p2,-16,stat | $3
                                sendmsg p2,$170,p3        :rr    =  stat       :swbreak ;STM_SETICON
                  case _STAB :  sendmsg p2,$40F,p4,p3     :rr    =  stat       :swbreak ;SB_SETICON

                  default    :  if (p4 == _NULL) {
                                sendmsg p2,$80,0,p3       :rr    =  stat       :swbreak};WM_SETICON
                              __SetClassLongA p2,-14,p3   :rr    =  stat       :swbreak ;GCL_HICON,GCL_HICONSM(-34)
                swend                                                          :swbreak
          case _IMAGE
                switch ss
                  case _TABC :  sendmsg p2,$1303, 0  ,p3  :rr    =  stat       :swbreak ;TCM_SETIMAGELIST
                  case _LSTV :  sendmsg p2,$1003,p4  ,p3  :rr    =  stat       :swbreak ;LVM_SETIMAGELIST
                  case _TREV :  sendmsg p2,$1109,p4^1,p3  :rr    =  stat       :swbreak ;TVM_SETIMAGELIST
                  default    :                            :rr    = -1          :swbreak
                swend                                                          :swbreak
          case _FONT                                      :await
                             :  sendmsg p2,$030,p3,1      :rr    =  stat
                             :__InvalidateRect  p2,0,1                         :swbreak
          case _HEIGHT
                switch ss
                  case _LSTB                              :await
                             :  sendmsg p2,$1A0,0,p3      :rr    = stat                 ;LB_SETITEMHEIGHT
                              __RedrawWindow p2,0,0,$401                       :swbreak
                  case _COMB                              :await
                             :  sendmsg p2,$153,0,p3                                    ;CB_SETITEMHEIGHT
                              __RedrawWindow p2,0,0,$401                       :swbreak
                  case _RICH
                  case _MESB :  if (p4 == _NULL) {
                                    sendmsg p2,$0D3,3,p3}                               ;EM_SETMARGINS
                              else {sendmsg p2,$0B3, ,p3} :rr    =  stat       :swbreak ;EM_SETRECT
                  case _STAB :      sendmsg p2,$408,p3    :sendmsg p2,$5                ;SB_SETMINHEIGHT
                                                          :rr    =  stat       :swbreak
                  default    :                            :rr    = -1          :swbreak
                swend                                                          :swbreak
          default :                                       :rr    = -1          :swbreak
   swend          :_Mint@Func = p2
return  rr
;|========.===========================.============[                    ]=====|
#define global ctype _Rsend(%1=0,%2=_Mint@Func,%3=_NULL,%4=_NULL,%5="",%6=0,%7=0) Send_Rsend(%1,%2,%3,%4,%5,%6,%7)
#define global ctype _Wsend(%1=0,%2=_Mint@Func,%3=_NULL,%4=_NULL,%5="",%6=0,%7=0) Send_Wsend(%1,%2,%3,%4,%5,%6,%7)
;|============================================================================|
#global
#endif
