;|=================================================[  UhspUtil.as       ]=====|
#ifndef        __UHSP_UTIL__
#define global __UHSP_UTIL__
#ifndef        __UHSP_FUNC__
#include "UhspFunc.as"
#endif
;|========.===========================.============[                    ]=====|
#uselib  "imagehlp.dll"
#func   global __SearchTreeForFile         "SearchTreeForFile"         sptr,sptr,sptr
#uselib  "advapi32.dll"
#func   global __RegCreateKeyExA           "RegCreateKeyExA"           sptr,sptr,sptr,sptr,sptr,sptr,sptr,sptr,sptr
#func   global __RegCloseKey               "RegCloseKey"               sptr
#func   global __RegOpenKeyExA             "RegOpenKeyExA"             sptr,sptr,sptr,sptr,sptr
#func   global __RegQueryValueExA          "RegQueryValueExA"          sptr,sptr,sptr,sptr,sptr,sptr
#func   global __RegSetValueExA            "RegSetValueExA"            sptr,sptr,sptr,sptr,sptr,sptr
;|========.===========================.============[                    ]=====|
#module   Util
#defcfunc Util_Speek var p1,int p2,int p3,int p4,local rr
             :rr  = "" :repeat  p2 :rr += strf("%02X",peek(p1,p3+cnt)) :if (p4) and (p2 != cnt+1) {rr += " "} :loop
return  rr
#deffunc  Util_Spoke var p1,str p2,int p3,int p4,local ii,local ss,local nn
             :ss  = p2 :            ss  =    strtrim(ss,3,32)
                       :repeat  p3 :nn  = "$"+strmid(ss,ii,2)          :if (nn == "$") {break} :poke p1,cnt+p4,int(nn) :ii += 2 :loop
return
#deffunc  Util_Sort array p1,int p2,int p3,int p4,local ii,local jj,local nn,local rr
          if (vartype(p1) != 2)   {rr = 1} :nn = p1((p3+p4)/2)                                            :ii(0) = p3,p4
  repeat :repeat :if (rr){if (p2) {if (p1(ii(0)) <=   nn) {break}} else {if (p1(ii(0)) >=   nn) {break}}}
               else      {if (p2) {if (p1(ii(0)) !nn!  1) {break}} else {if (p1(ii(0)) !nn! -1) {break}}} :ii(0)++ :loop
          repeat :if (rr){if (p2) {if (nn  <=  p1(ii(1))) {break}} else {if (nn  >=  p1(ii(1))) {break}}}
               else      {if (p2) {if (nn !p1(ii(1))!  1) {break}} else {if (nn !p1(ii(1))! -1) {break}}} :ii(1)-- :loop
          if (ii(0)  >=  ii(1))   {break }                                        :await
          jj = p1(ii(0)) :p1(ii(0)) = p1(ii(1)) :p1(ii(1)) = jj :ii(0)++ :ii(1)-- :loop
          if (p3      <ii(0)-1)   {Util_Sort p1,p2,p3     ,ii(0)-1}
          if (ii(1)+1 <     p4)   {Util_Sort p1,p2,ii(1)+1,     p4}
return
#deffunc  Util_Sort2 var p1,int p2,str p3,local ss,local rr
          split p1,p3,ss :rr = stat  :if (rr <= 0) {return 0}   :Util_Sort ss,p2,0,rr-1
                p1 = ""  :repeat rr  :p1 += ss(cnt)+p3          :loop             :p1 = (strmid(p1,0,strlen@hsp(p1)-1))
return
#defcfunc Util_Spc int p1,str p2,local rr
          if (p2  != "") {_Mstr@Func(4) = p2}   :rr = ""        :repeat abs(p1)   :rr+= _Mstr@Func(4) :loop
return  rr
#defcfunc Util_Temp int p1,str p2,local ii,local ss
          sdim ss,p1,2   :ss = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ"             :if (p2 != "") {ss = p2}
                ii =  strlen@hsp(ss) :repeat p1 :poke ss(1),cnt,peek(ss,rnd(ii))  :loop
return  ss(1)
;|========.===========================.============[                    ]=====|
#defcfunc Util_Exist str p1,local ss,local nn,local rr
              ss  =  p1  :dim nn,80  :__FindFirstFileA varptr(ss),varptr(nn)         : rr = stat
                                     :__FindClose   rr:_Hdbl@Func = double(nn)       :_Hctx@Func(197) = nn(8)
          if (rr  == -1) {return -3} :__CreateFileA varptr(ss),$C0000000,0,0,3,$80,0 : rr = stat 
          if (rr  != -1) {            __CloseHandle rr: rr = 0}  :if (rr == -1) and ((nn & 16) == 0) {rr--}
return  rr
#defcfunc Util_Which str p1,str p2,local rr
          sdim rr,512
          if (p2  == "") {__SearchPathA 0,p1,0,512,varptr(rr),0} else {__SearchTreeForFile p2,p1,varptr(rr)}
return  rr
#defcfunc Util_GetReg str p1,str p2,int p3,local ii,local jj,local nn,local rr
          __RegOpenKeyExA   $80000000+p3,Func_Rchr(p1,47,92,_Uany@Func),0,1,varptr(ii)
                                                             :if (stat      ) {return _NULL}
          __RegQueryValueExA ii,p2,0,varptr(nn),0,varptr(jj) :if (nn   ==  4) {dim rr :jj = 4} else {sdim rr,jj}
          __RegQueryValueExA ii,p2,0,0,varptr(rr),varptr(jj) :if (stat      ) {rr  =  _NULL}
          __RegCloseKey      ii
return  rr
#defcfunc Util_SetReg str p1,str p2,str p3,int p4,int p5,local ii,local rr
          __RegCreateKeyExA $80000000+p5,Func_Rchr(p1,47,92,_Uany@Func),0,0,0,$00020006,0,varptr(rr),0
                                                             :if (stat      ) {return _NULL}
          if (p4) {ii = int(p3) :__RegSetValueExA rr,p2,0,$4,varptr(ii),           4}
        else      {ii =     p3  :__RegSetValueExA rr,p2,0,$1,varptr(ii),strlen@hsp(ii)+1} :__RegCloseKey rr
return  rr
#defcfunc Util_Profile int p1,str p2,str p3,str p4,int p5,local rr
          if (p1  !=  2) {                    :exist _Mstr@Func(2)      :rr  =  strsize}
          if (p1  ==  2) {_Mstr@Func(2) = p2  :exist _Mstr@Func(2)      :rr  =  strsize
                           if (rr == -1)      {bsave _Mstr@Func(2),rr,0 :rr  =  stat}}
     else:if (p1  ==  1) { if (rr >  -1)      {               :__WritePrivateProfileStringA p2,p3,p4,_Mstr@Func(2)}}
     else                { if (rr >  -1)      {sdim   rr,512  :__GetPrivateProfileStringA   p2,p3,p4,varptr(rr),512,_Mstr@Func(2)}
                         else                 {                         :rr  = -1}}
          if (p5  ==  1) { rr  =  int(rr)}     else:if (p5 ==  2)       {rr  =  double(rr)}
return  rr
#defcfunc Util_Fps double p1,double p2,array p3,local rr
          repeat :rr = Func_Count(0,p3),rr-p3(3) :if (rr(1) > p1) {break} :if (rr(1) <= p2) {await 1} :loop :p3(3) = Func_Count(0,p3)
return    1000.0/rr(1)
;|========.===========================.============[                    ]=====|
#define global ctype _Speek(%1=0,%2=0,%3=0,%4=0)                                   Util_Speek(%1,%2,%3,%4)
#define global       _Spoke(%1=0,%2="",%3=0,%4=0)                                  Util_Spoke %1,%2,%3,%4
#define global       _Sort(%1=_Ures@Func,%2=0)                                     Util_Sort %1,%2,0,length(%1)-1
#define global       _Sort2(%1=_Ures@Func,%2=0,%3="\\n")                           Util_Sort2 %1,%2,%3
#define global ctype _Spc(%1=0,%2="")                                              Util_Spc(%1,%2)
#define global ctype _TmpName(%1=8,%2="")                                          Util_Temp(%1,%2)
#define global ctype _Exist(%1="")                                                 Util_Exist(%1)
#define global ctype _Which(%1="hsp3.exe",%2="")                                   Util_Which(%1,%2)
#define global ctype _GetReg(%1="Software/OnionSoftware/hsed3_3/",%2="exewx",%3=1) Util_GetReg(%1,%2,%3)
#define global ctype _SetReg(%1="Software/__UHSP__/data",%2="",%3="",%4=0,%5=1)    Util_SetReg(%1,%2,%3,%4,%5)
#define global ctype _Profile(%1=0,%2="",%3="",%4="",%5=0)                         Util_Profile(%1,%2,%3,%4,%5)
#define global ctype _Fps(%1=16.6,%2=2,%3=_Mdbl@Func)                              Util_Fps(%1,%2,%3)
#define global       _UnExit await :if (iparam | wparam = 0) or (wparam < 0) {end} :gsel@hsp wparam ,-1 :gsel 0 :return
;|============================================================================|
#global
#endif
