;|=================================================[  UhspWind.as       ]=====|
#ifndef        __UHSP_WIND__
#define global __UHSP_WIND__
#ifndef        __UHSP_FUNC__
#include "UhspFunc.as"
#endif
;|========.===========================.============[                    ]=====|
#module   Wind
;|========.===========================.============[                    ]=====|
#enum   global  _ALPHA            =  0
#enum   global  _ANIMATE
#enum   global  _FLASH
#enum   global  _THEME
#enum   global  _TRAY
#enum   global  _REGION
;|========.===========================.============[                    ]=====|
#defcfunc Wind_Fsend int p1,int p2,int p3,int p4,int p5,str p6,local nn,local ss,local rr
   switch p1
          case _ALPHA        :__GetWindowLongA  p2,-20
                                if (p4 !=  0) {if (stat & $80000) != $80000 {
                                               __SetWindowLongA p2,-20,stat | $80000}
                                if (p4 ==  1) {__SetLayeredWindowAttributes p2,p3,0,1}                     ; alpha   / color
                         else:  if (p4 ==  2) {__SetLayeredWindowAttributes p2,0,p3,2}}                    ;         / window
                         else                 {__SetWindowLongA p2,-20,stat-(stat&$80000)}                 ;         / off
                                                                          :rr    =  stat          :swbreak
          case _ANIMATE      :  nn = 0,1,2,4,8,$10,$80000
                             :  nn = nn(limit(abs(p4),1,6))|_Iif(p4<=0,$10000,$20000)
                              __AnimateWindow  p2,p5,nn                   :rr    =  stat          :swbreak ; animate /
          case _FLASH        :                                            :nn    = 20,p2,p3,p4,p5
                              __FlashWindowEx  varptr(nn)                 :rr    =  stat          :swbreak ; flash   /
          case _THEME        :  if (p4 ==  1) {__SetWindowTheme p2,"",""}
                         else:  if (p4 ==  2) {__OpenThemeData  hwnd ,p5}
                         else:  if (p4 ==  3) {__CloseThemeData p2      }
                         else                 {__SetWindowTheme p2, 0, 0} :rr    =  stat          :swbreak ; theme   /
          case _TRAY         :  dim nn,122
                   switch p4
                     case  1 :  nn(  5) =  p5
                                nn      =  88,p2,p3,7,$900    ; _TRAYEVENTSTART
                                              :if (p5  ==  0) {__GetClassLongA p2,-14 :nn(5) = stat}
                                              :poke nn, 24,p6 :__Shell_NotifyIconA 0,varptr(nn)   :swbreak
                     case  2 :  nn      = 488,p2,p3,$10
                                nn(104) =  p5 :poke nn,160,Func_Split(p6+"| ","|",ss,2)
                                nn(121) =   0 :poke nn,420,ss :__Shell_NotifyIconA 1,varptr(nn)   :swbreak
                     case  3 :  nn      = 488,p2,p3,$10       :__Shell_NotifyIconA 1,varptr(nn)   :swbreak
                     default :  nn      =  88,p2,p3           :__Shell_NotifyIconA 2,varptr(nn)   :swbreak
                   swend                                                  :rr    =  stat          :swbreak ; tray    /
          case _REGION       :__SetWindowRgn  p2,p3,p4                    :rr    =  stat          :swbreak ; region  /
          default            :                                            :rr    = -1             :swbreak
   swend                     : _Mint@Func = p2
return  rr
#defcfunc Wind_RgnCreate int p1,local ii,local jj,local rr,local nn
                     if (Func_Usid(p1,ii) == -1) {return -1}
          Func_Bswap -3,p1       :mref nn,66:dim ii,131072:dim jj,131072
               pget 0,0 :rr(0)  = ginfo_winx,ginfo_winy,ginfo_r,ginfo_g,ginfo_b,0,rr(1),0,0,0,0
          Func_Bswap -1
   repeat rr( 1):repeat rr( 0)
                        rr(11) = peek(nn,rr( 8)):rr( 8)++ :rr(12) = peek(nn,rr( 8))      :rr( 8)++
                        rr(13) = peek(nn,rr( 8)):rr( 8)++
                    if (rr( 0) == rr( 5)+1) or ((rr(13) == rr( 2)) and (rr(12) == rr( 3)) and (rr(11) == rr( 4))) {
                    if (rr( 7) ==        1)  {ii(rr( 9)) = rr( 5),rr( 6)-1,rr( 5),rr( 6) :rr( 9)+= 4
                                              jj(rr(10)) = 4     :rr(10)++               :rr( 7) = 0}}
              else {if (rr( 7) ==        0)  {ii(rr( 9)) = rr( 5),rr( 6),rr( 5),rr( 6)-1 :rr( 9)+= 4 :rr( 7) = 1}}
                                                                 :rr( 5)++
                 loop                                            :rr( 6)--               :rr( 5) = 0
   loop         :    __CreatePolyPolygonRgn varptr(ii),varptr(jj),rr(10),2               :rr(14) = stat
return  rr(14)
;|========.===========================.============[                    ]=====|
#define global ctype _Fsend(%1=0,%2=_Mint@Func,%3=0,%4=0,%5=0,%6="")     Wind_Fsend(%1,%2,%3,%4,%5,%6)
#define global ctype _RgnCreate(%1=0)                                    Wind_RgnCreate(%1)
;|============================================================================|
#global
#endif
