;|=================================================[  UhspXapi.as       ]=====|
#ifndef        __UHSP_XAPI__
#define global __UHSP_XAPI__
#ifndef        __UHSP_FUNC__
#include "UhspFunc.as"
#endif
;|========.===========================.============[                    ]=====|
               __LoadLibraryA              "SCILEXER.DLL"
               __SetLastError  0
;|========.===========================.============[                    ]=====|
#const  global INVALID_POSITION                    -1
#const  global SCI_START                           2000
#const  global SCI_OPTIONAL_START                  3000
#const  global SCI_LEXER_START                     4000
#const  global SCI_ADDTEXT                         2001
#const  global SCI_ADDSTYLEDTEXT                   2002
#const  global SCI_INSERTTEXT                      2003
#const  global SCI_CLEARALL                        2004
#const  global SCI_CLEARDOCUMENTSTYLE              2005
#const  global SCI_GETLENGTH                       2006
#const  global SCI_GETCHARAT                       2007
#const  global SCI_GETCURRENTPOS                   2008
#const  global SCI_GETANCHOR                       2009
#const  global SCI_GETSTYLEAT                      2010
#const  global SCI_REDO                            2011
#const  global SCI_SETUNDOCOLLECTION               2012
#const  global SCI_SELECTALL                       2013
#const  global SCI_SETSAVEPOINT                    2014
#const  global SCI_GETSTYLEDTEXT                   2015
#const  global SCI_CANREDO                         2016
#const  global SCI_MARKERLINEFROMHANDLE            2017
#const  global SCI_MARKERDELETEHANDLE              2018
#const  global SCI_GETUNDOCOLLECTION               2019
#const  global SCI_GETVIEWWS                       2020
#const  global SCI_SETVIEWWS                       2021
#const  global SCI_POSITIONFROMPOINT               2022
#const  global SCI_POSITIONFROMPOINTCLOSE          2023
#const  global SCI_GOTOLINE                        2024
#const  global SCI_GOTOPOS                         2025
#const  global SCI_SETANCHOR                       2026
#const  global SCI_GETCURLINE                      2027
#const  global SCI_GETENDSTYLED                    2028
#const  global SCI_CONVERTEOLS                     2029
#const  global SCI_GETEOLMODE                      2030
#const  global SCI_SETEOLMODE                      2031
#const  global SCI_STARTSTYLING                    2032
#const  global SCI_SETSTYLING                      2033
#const  global SCI_GETBUFFEREDDRAW                 2034
#const  global SCI_SETBUFFEREDDRAW                 2035
#const  global SCI_SETTABWIDTH                     2036
#const  global SCI_GETTABWIDTH                     2121
#const  global SCI_SETCODEPAGE                     2037
#const  global SCI_SETUSEPALETTE                   2039
#const  global SCI_MARKERDEFINE                    2040
#const  global SCI_MARKERSETFORE                   2041
#const  global SCI_MARKERSETBACK                   2042
#const  global SCI_MARKERADD                       2043
#const  global SCI_MARKERDELETE                    2044
#const  global SCI_MARKERDELETEALL                 2045
#const  global SCI_MARKERGET                       2046
#const  global SCI_MARKERNEXT                      2047
#const  global SCI_MARKERPREVIOUS                  2048
#const  global SCI_MARKERDEFINEPIXMAP              2049
#const  global SCI_SETMARGINTYPEN                  2240
#const  global SCI_GETMARGINTYPEN                  2241
#const  global SCI_SETMARGINWIDTHN                 2242
#const  global SCI_GETMARGINWIDTHN                 2243
#const  global SCI_SETMARGINMASKN                  2244
#const  global SCI_GETMARGINMASKN                  2245
#const  global SCI_SETMARGINSENSITIVEN             2246
#const  global SCI_GETMARGINSENSITIVEN             2247
#const  global SCI_STYLECLEARALL                   2050
#const  global SCI_STYLESETFORE                    2051
#const  global SCI_STYLESETBACK                    2052
#const  global SCI_STYLESETBOLD                    2053
#const  global SCI_STYLESETITALIC                  2054
#const  global SCI_STYLESETSIZE                    2055
#const  global SCI_STYLESETFONT                    2056
#const  global SCI_STYLESETEOLFILLED               2057
#const  global SCI_STYLERESETDEFAULT               2058
#const  global SCI_STYLESETUNDERLINE               2059
#const  global SCI_STYLESETCASE                    2060
#const  global SCI_STYLESETCHARACTERSET            2066
#const  global SCI_SETSELFORE                      2067
#const  global SCI_SETSELBACK                      2068
#const  global SCI_SETCARETFORE                    2069
#const  global SCI_ASSIGNCMDKEY                    2070
#const  global SCI_CLEARCMDKEY                     2071
#const  global SCI_CLEARALLCMDKEYS                 2072
#const  global SCI_SETSTYLINGEX                    2073
#const  global SCI_STYLESETVISIBLE                 2074
#const  global SCI_GETCARETPERIOD                  2075
#const  global SCI_SETCARETPERIOD                  2076
#const  global SCI_SETWORDCHARS                    2077
#const  global SCI_BEGINUNDOACTION                 2078
#const  global SCI_ENDUNDOACTION                   2079
#const  global SCI_INDICSETSTYLE                   2080
#const  global SCI_INDICGETSTYLE                   2081
#const  global SCI_INDICSETFORE                    2082
#const  global SCI_INDICGETFORE                    2083
#const  global SCI_SETWHITESPACEFORE               2084
#const  global SCI_SETWHITESPACEBACK               2085
#const  global SCI_SETSTYLEBITS                    2090
#const  global SCI_GETSTYLEBITS                    2091
#const  global SCI_SETLINESTATE                    2092
#const  global SCI_GETLINESTATE                    2093
#const  global SCI_GETMAXLINESTATE                 2094
#const  global SCI_GETCARETLINEVISIBLE             2095
#const  global SCI_SETCARETLINEVISIBLE             2096
#const  global SCI_GETCARETLINEBACK                2097
#const  global SCI_SETCARETLINEBACK                2098
#const  global SCI_STYLESETCHANGEABLE              2099
#const  global SCI_AUTOCSHOW                       2100
#const  global SCI_AUTOCCANCEL                     2101
#const  global SCI_AUTOCACTIVE                     2102
#const  global SCI_AUTOCPOSSTART                   2103
#const  global SCI_AUTOCCOMPLETE                   2104
#const  global SCI_AUTOCSTOPS                      2105
#const  global SCI_AUTOCSETSEPARATOR               2106
#const  global SCI_AUTOCGETSEPARATOR               2107
#const  global SCI_AUTOCSELECT                     2108
#const  global SCI_AUTOCSETCANCELATSTART           2110
#const  global SCI_AUTOCGETCANCELATSTART           2111
#const  global SCI_AUTOCSETFILLUPS                 2112
#const  global SCI_AUTOCSETCHOOSESINGLE            2113
#const  global SCI_AUTOCGETCHOOSESINGLE            2114
#const  global SCI_AUTOCSETIGNORECASE              2115
#const  global SCI_AUTOCGETIGNORECASE              2116
#const  global SCI_USERLISTSHOW                    2117
#const  global SCI_AUTOCSETAUTOHIDE                2118
#const  global SCI_AUTOCGETAUTOHIDE                2119
#const  global SCI_AUTOCSETDROPRESTOFWORD          2270
#const  global SCI_AUTOCGETDROPRESTOFWORD          2271
#const  global SCI_SETINDENT                       2122
#const  global SCI_GETINDENT                       2123
#const  global SCI_SETUSETABS                      2124
#const  global SCI_GETUSETABS                      2125
#const  global SCI_SETLINEINDENTATION              2126
#const  global SCI_GETLINEINDENTATION              2127
#const  global SCI_GETLINEINDENTPOSITION           2128
#const  global SCI_GETCOLUMN                       2129
#const  global SCI_SETHSCROLLBAR                   2130
#const  global SCI_GETHSCROLLBAR                   2131
#const  global SCI_SETINDENTATIONGUIDES            2132
#const  global SCI_GETINDENTATIONGUIDES            2133
#const  global SCI_SETHIGHLIGHTGUIDE               2134
#const  global SCI_GETHIGHLIGHTGUIDE               2135
#const  global SCI_GETLINEENDPOSITION              2136
#const  global SCI_GETCODEPAGE                     2137
#const  global SCI_GETCARETFORE                    2138
#const  global SCI_GETUSEPALETTE                   2139
#const  global SCI_GETREADONLY                     2140
#const  global SCI_SETCURRENTPOS                   2141
#const  global SCI_SETSELECTIONSTART               2142
#const  global SCI_GETSELECTIONSTART               2143
#const  global SCI_SETSELECTIONEND                 2144
#const  global SCI_GETSELECTIONEND                 2145
#const  global SCI_SETPRINTMAGNIFICATION           2146
#const  global SCI_GETPRINTMAGNIFICATION           2147
#const  global SCI_SETPRINTCOLOURMODE              2148
#const  global SCI_GETPRINTCOLOURMODE              2149
#const  global SCI_FINDTEXT                        2150
#const  global SCI_FORMATRANGE                     2151
#const  global SCI_GETFIRSTVISIBLELINE             2152
#const  global SCI_GETLINE                         2153
#const  global SCI_GETLINECOUNT                    2154
#const  global SCI_SETMARGINLEFT                   2155
#const  global SCI_GETMARGINLEFT                   2156
#const  global SCI_SETMARGINRIGHT                  2157
#const  global SCI_GETMARGINRIGHT                  2158
#const  global SCI_GETMODIFY                       2159
#const  global SCI_SETSEL                          2160
#const  global SCI_GETSELTEXT                      2161
#const  global SCI_GETTEXTRANGE                    2162
#const  global SCI_HIDESELECTION                   2163
#const  global SCI_POINTXFROMPOSITION              2164
#const  global SCI_POINTYFROMPOSITION              2165
#const  global SCI_LINEFROMPOSITION                2166
#const  global SCI_POSITIONFROMLINE                2167
#const  global SCI_LINESCROLL                      2168
#const  global SCI_SCROLLCARET                     2169
#const  global SCI_REPLACESEL                      2170
#const  global SCI_SETREADONLY                     2171
#const  global SCI_NULL                            2172
#const  global SCI_CANPASTE                        2173
#const  global SCI_CANUNDO                         2174
#const  global SCI_EMPTYUNDOBUFFER                 2175
#const  global SCI_UNDO                            2176
#const  global SCI_CUT                             2177
#const  global SCI_COPY                            2178
#const  global SCI_PASTE                           2179
#const  global SCI_CLEAR                           2180
#const  global SCI_SETTEXT                         2181
#const  global SCI_GETTEXT                         2182
#const  global SCI_GETTEXTLENGTH                   2183
#const  global SCI_GETDIRECTFUNCTION               2184
#const  global SCI_GETDIRECTPOINTER                2185
#const  global SCI_SETOVERTYPE                     2186
#const  global SCI_GETOVERTYPE                     2187
#const  global SCI_SETCARETWIDTH                   2188
#const  global SCI_GETCARETWIDTH                   2189
#const  global SCI_SETTARGETSTART                  2190
#const  global SCI_GETTARGETSTART                  2191
#const  global SCI_SETTARGETEND                    2192
#const  global SCI_GETTARGETEND                    2193
#const  global SCI_REPLACETARGET                   2194
#const  global SCI_REPLACETARGETRE                 2195
#const  global SCI_SEARCHINTARGET                  2197
#const  global SCI_SETSEARCHFLAGS                  2198
#const  global SCI_GETSEARCHFLAGS                  2199
#const  global SCI_CALLTIPSHOW                     2200
#const  global SCI_CALLTIPCANCEL                   2201
#const  global SCI_CALLTIPACTIVE                   2202
#const  global SCI_CALLTIPPOSSTART                 2203
#const  global SCI_CALLTIPSETHLT                   2204
#const  global SCI_CALLTIPSETBACK                  2205
#const  global SCI_CALLTIPSETFORE                  2206
#const  global SCI_CALLTIPSETFOREHLT               2207
#const  global SCI_AUTOCSETMAXWIDTH                2208
#const  global SCI_AUTOCGETMAXWIDTH                2209
#const  global SCI_AUTOCSETMAXHEIGHT               2210
#const  global SCI_AUTOCGETMAXHEIGHT               2211
#const  global SCI_CALLTIPUSESTYLE                 2212
#const  global SCI_VISIBLEFROMDOCLINE              2220
#const  global SCI_DOCLINEFROMVISIBLE              2221
#const  global SCI_SETFOLDLEVEL                    2222
#const  global SCI_GETFOLDLEVEL                    2223
#const  global SCI_GETLASTCHILD                    2224
#const  global SCI_GETFOLDPARENT                   2225
#const  global SCI_SHOWLINES                       2226
#const  global SCI_HIDELINES                       2227
#const  global SCI_GETLINEVISIBLE                  2228
#const  global SCI_SETFOLDEXPANDED                 2229
#const  global SCI_GETFOLDEXPANDED                 2230
#const  global SCI_TOGGLEFOLD                      2231
#const  global SCI_ENSUREVISIBLE                   2232
#const  global SCI_SETFOLDFLAGS                    2233
#const  global SCI_ENSUREVISIBLEENFORCEPOLICY      2234
#const  global SCI_WRAPCOUNT                       2235
#const  global SCI_SETTABINDENTS                   2260
#const  global SCI_GETTABINDENTS                   2261
#const  global SCI_SETBACKSPACEUNINDENTS           2262
#const  global SCI_GETBACKSPACEUNINDENTS           2263
#const  global SCI_SETMOUSEDWELLTIME               2264
#const  global SCI_GETMOUSEDWELLTIME               2265
#const  global SCI_WORDSTARTPOSITION               2266
#const  global SCI_WORDENDPOSITION                 2267
#const  global SCI_SETWRAPMODE                     2268
#const  global SCI_GETWRAPMODE                     2269
#const  global SCI_SETLAYOUTCACHE                  2272
#const  global SCI_GETLAYOUTCACHE                  2273
#const  global SCI_SETSCROLLWIDTH                  2274
#const  global SCI_GETSCROLLWIDTH                  2275
#const  global SCI_TEXTWIDTH                       2276
#const  global SCI_SETENDATLASTLINE                2277
#const  global SCI_GETENDATLASTLINE                2278
#const  global SCI_TEXTHEIGHT                      2279
#const  global SCI_SETVSCROLLBAR                   2280
#const  global SCI_GETVSCROLLBAR                   2281
#const  global SCI_APPENDTEXT                      2282
#const  global SCI_GETTWOPHASEDRAW                 2283
#const  global SCI_SETTWOPHASEDRAW                 2284
#const  global SCI_AUTOCGETTYPESEPARATOR           2285
#const  global SCI_AUTOCSETTYPESEPARATOR           2286
#const  global SCI_TARGETFROMSELECTION             2287
#const  global SCI_LINESJOIN                       2288
#const  global SCI_LINESSPLIT                      2289
#const  global SCI_SETFOLDMARGINCOLOUR             2290
#const  global SCI_SETFOLDMARGINHICOLOUR           2291
#const  global SCI_LINEDOWN                        2300
#const  global SCI_LINEDOWNEXTEND                  2301
#const  global SCI_LINEUP                          2302
#const  global SCI_LINEUPEXTEND                    2303
#const  global SCI_CHARLEFT                        2304
#const  global SCI_CHARLEFTEXTEND                  2305
#const  global SCI_CHARRIGHT                       2306
#const  global SCI_CHARRIGHTEXTEND                 2307
#const  global SCI_WORDLEFT                        2308
#const  global SCI_WORDLEFTEXTEND                  2309
#const  global SCI_WORDRIGHT                       2310
#const  global SCI_WORDRIGHTEXTEND                 2311
#const  global SCI_HOME                            2312
#const  global SCI_HOMEEXTEND                      2313
#const  global SCI_LINEEND                         2314
#const  global SCI_LINEENDEXTEND                   2315
#const  global SCI_DOCUMENTSTART                   2316
#const  global SCI_DOCUMENTSTARTEXTEND             2317
#const  global SCI_DOCUMENTEND                     2318
#const  global SCI_DOCUMENTENDEXTEND               2319
#const  global SCI_PAGEUP                          2320
#const  global SCI_PAGEUPEXTEND                    2321
#const  global SCI_PAGEDOWN                        2322
#const  global SCI_PAGEDOWNEXTEND                  2323
#const  global SCI_EDITTOGGLEOVERTYPE              2324
#const  global SCI_CANCEL                          2325
#const  global SCI_DELETEBACK                      2326
#const  global SCI_TAB                             2327
#const  global SCI_BACKTAB                         2328
#const  global SCI_NEWLINE                         2329
#const  global SCI_FORMFEED                        2330
#const  global SCI_VCHOME                          2331
#const  global SCI_VCHOMEEXTEND                    2332
#const  global SCI_ZOOMIN                          2333
#const  global SCI_ZOOMOUT                         2334
#const  global SCI_DELWORDLEFT                     2335
#const  global SCI_DELWORDRIGHT                    2336
#const  global SCI_LINECUT                         2337
#const  global SCI_LINEDELETE                      2338
#const  global SCI_LINETRANSPOSE                   2339
#const  global SCI_LOWERCASE                       2340
#const  global SCI_UPPERCASE                       2341
#const  global SCI_LINESCROLLDOWN                  2342
#const  global SCI_LINESCROLLUP                    2343
#const  global SCI_DELETEBACKNOTLINE               2344
#const  global SCI_HOMEDISPLAY                     2345
#const  global SCI_HOMEDISPLAYEXTEND               2346
#const  global SCI_LINEENDDISPLAY                  2347
#const  global SCI_LINEENDDISPLAYEXTEND            2348
#const  global SCI_MOVECARETINSIDEVIEW             2401
#const  global SCI_LINELENGTH                      2350
#const  global SCI_BRACEHIGHLIGHT                  2351
#const  global SCI_BRACEBADLIGHT                   2352
#const  global SCI_BRACEMATCH                      2353
#const  global SCI_GETVIEWEOL                      2355
#const  global SCI_SETVIEWEOL                      2356
#const  global SCI_GETDOCPOINTER                   2357
#const  global SCI_SETDOCPOINTER                   2358
#const  global SCI_SETMODEVENTMASK                 2359
#const  global SCI_GETEDGECOLUMN                   2360
#const  global SCI_SETEDGECOLUMN                   2361
#const  global SCI_GETEDGEMODE                     2362
#const  global SCI_SETEDGEMODE                     2363
#const  global SCI_GETEDGECOLOUR                   2364
#const  global SCI_SETEDGECOLOUR                   2365
#const  global SCI_SEARCHANCHOR                    2366
#const  global SCI_SEARCHNEXT                      2367
#const  global SCI_SEARCHPREV                      2368
#const  global SCI_LINESONSCREEN                   2370
#const  global SCI_USEPOPUP                        2371
#const  global SCI_SELECTIONISRECTANGLE            2372
#const  global SCI_SETZOOM                         2373
#const  global SCI_GETZOOM                         2374
#const  global SCI_CREATEDOCUMENT                  2375
#const  global SCI_ADDREFDOCUMENT                  2376
#const  global SCI_RELEASEDOCUMENT                 2377
#const  global SCI_GETMODEVENTMASK                 2378
#const  global SCI_SETFOCUS                        2380
#const  global SCI_GETFOCUS                        2381
#const  global SCI_SETSTATUS                       2382
#const  global SCI_GETSTATUS                       2383
#const  global SCI_SETMOUSEDOWNCAPTURES            2384
#const  global SCI_GETMOUSEDOWNCAPTURES            2385
#const  global SCI_SETCURSOR                       2386
#const  global SCI_GETCURSOR                       2387
#const  global SCI_SETCONTROLCHARSYMBOL            2388
#const  global SCI_GETCONTROLCHARSYMBOL            2389
#const  global SCI_WORDPARTLEFT                    2390
#const  global SCI_WORDPARTLEFTEXTEND              2391
#const  global SCI_WORDPARTRIGHT                   2392
#const  global SCI_WORDPARTRIGHTEXTEND             2393
#const  global SCI_SETVISIBLEPOLICY                2394
#const  global SCI_DELLINELEFT                     2395
#const  global SCI_DELLINERIGHT                    2396
#const  global SCI_SETXOFFSET                      2397
#const  global SCI_GETXOFFSET                      2398
#const  global SCI_CHOOSECARETX                    2399
#const  global SCI_GRABFOCUS                       2400
#const  global SCI_SETXCARETPOLICY                 2402
#const  global SCI_SETYCARETPOLICY                 2403
#const  global SCI_LINEDUPLICATE                   2404
#const  global SCI_REGISTERIMAGE                   2405
#const  global SCI_SETPRINTWRAPMODE                2406
#const  global SCI_GETPRINTWRAPMODE                2407
#const  global SCI_CLEARREGISTEREDIMAGES           2408
#const  global SCI_STYLESETHOTSPOT                 2409
#const  global SCI_SETHOTSPOTACTIVEFORE            2410
#const  global SCI_SETHOTSPOTACTIVEBACK            2411
#const  global SCI_SETHOTSPOTACTIVEUNDERLINE       2412
#const  global SCI_PARADOWN                        2413
#const  global SCI_PARADOWNEXTEND                  2414
#const  global SCI_PARAUP                          2415
#const  global SCI_PARAUPEXTEND                    2416
#const  global SCI_POSITIONBEFORE                  2417
#const  global SCI_POSITIONAFTER                   2418
#const  global SCI_COPYRANGE                       2419
#const  global SCI_COPYTEXT                        2420
#const  global SCI_SETSELECTIONMODE                2422
#const  global SCI_GETSELECTIONMODE                2423
#const  global SCI_GETLINESELSTARTPOSITION         2424
#const  global SCI_GETLINESELENDPOSITION           2425
#const  global SCI_LINEDOWNRECTEXTEND              2426
#const  global SCI_LINEUPRECTEXTEND                2427
#const  global SCI_CHARLEFTRECTEXTEND              2428
#const  global SCI_CHARRIGHTRECTEXTEND             2429
#const  global SCI_HOMERECTEXTEND                  2430
#const  global SCI_VCHOMERECTEXTEND                2431
#const  global SCI_LINEENDRECTEXTEND               2432
#const  global SCI_PAGEUPRECTEXTEND                2433
#const  global SCI_PAGEDOWNRECTEXTEND              2434
#const  global SCI_STUTTEREDPAGEUP                 2435
#const  global SCI_STUTTEREDPAGEUPEXTEND           2436
#const  global SCI_STUTTEREDPAGEDOWN               2437
#const  global SCI_STUTTEREDPAGEDOWNEXTEND         2438
#const  global SCI_WORDLEFTEND                     2439
#const  global SCI_WORDLEFTENDEXTEND               2440
#const  global SCI_WORDRIGHTEND                    2441
#const  global SCI_WORDRIGHTENDEXTEND              2442
#const  global SCI_SETWHITESPACECHARS              2443
#const  global SCI_SETCHARSDEFAULT                 2444
#const  global SCI_AUTOCGETCURRENT                 2445
#const  global SCI_ALLOCATE                        2446
#const  global SCI_HOMEWRAP                        2349
#const  global SCI_HOMEWRAPEXTEND                  2450
#const  global SCI_LINEENDWRAP                     2451
#const  global SCI_LINEENDWRAPEXTEND               2452
#const  global SCI_VCHOMEWRAP                      2453
#const  global SCI_VCHOMEWRAPEXTEND                2454
#const  global SCI_LINECOPY                        2455
#const  global SCI_FINDCOLUMN                      2456
#const  global SCI_GETCARETSTICKY                  2457
#const  global SCI_SETCARETSTICKY                  2458
#const  global SCI_TOGGLECARETSTICKY               2459
#const  global SCI_SETWRAPVISUALFLAGS              2460
#const  global SCI_GETWRAPVISUALFLAGS              2461
#const  global SCI_SETWRAPVISUALFLAGSLOCATION      2462
#const  global SCI_GETWRAPVISUALFLAGSLOCATION      2463
#const  global SCI_SETWRAPSTARTINDENT              2464
#const  global SCI_GETWRAPSTARTINDENT              2465
#const  global SCI_MARKERADDSET                    2466
#const  global SCI_SETPASTECONVERTENDINGS          2467
#const  global SCI_GETPASTECONVERTENDINGS          2468
#const  global SCI_SELECTIONDUPLICATE              2469
#const  global SCI_SETCARETLINEBACKALPHA           2470
#const  global SCI_GETCARETLINEBACKALPHA           2471
#const  global SCI_MARKERSETALPHA                  2476
#const  global SCI_GETSELALPHA                     2477
#const  global SCI_SETSELALPHA                     2478
#const  global SCI_GETSELEOLFILLED                 2479
#const  global SCI_SETSELEOLFILLED                 2480
#const  global SCI_STYLEGETFORE                    2481
#const  global SCI_STYLEGETBACK                    2482
#const  global SCI_STYLEGETBOLD                    2483
#const  global SCI_STYLEGETITALIC                  2484
#const  global SCI_STYLEGETSIZE                    2485
#const  global SCI_STYLEGETFONT                    2486
#const  global SCI_STYLEGETEOLFILLED               2487
#const  global SCI_STYLEGETUNDERLINE               2488
#const  global SCI_STYLEGETCASE                    2489
#const  global SCI_STYLEGETCHARACTERSET            2490
#const  global SCI_STYLEGETVISIBLE                 2491
#const  global SCI_STYLEGETCHANGEABLE              2492
#const  global SCI_STYLEGETHOTSPOT                 2493
#const  global SCI_GETHOTSPOTACTIVEFORE            2494
#const  global SCI_GETHOTSPOTACTIVEBACK            2495
#const  global SCI_GETHOTSPOTACTIVEUNDERLINE       2496
#const  global SCI_GETHOTSPOTSINGLELINE            2497
#const  global SCI_SETINDICATORCURRENT             2500
#const  global SCI_GETINDICATORCURRENT             2501
#const  global SCI_SETINDICATORVALUE               2502
#const  global SCI_GETINDICATORVALUE               2503
#const  global SCI_INDICATORFILLRANGE              2504
#const  global SCI_INDICATORCLEARRANGE             2505
#const  global SCI_INDICATORALLONFOR               2506
#const  global SCI_INDICATORVALUEAT                2507
#const  global SCI_INDICATORSTART                  2508
#const  global SCI_INDICATOREND                    2509
#const  global SCI_INDICSETUNDER                   2510
#const  global SCI_INDICGETUNDER                   2511
#const  global SCI_SETCARETSTYLE                   2512
#const  global SCI_GETCARETSTYLE                   2513
#const  global SCI_SETPOSITIONCACHE                2514
#const  global SCI_GETPOSITIONCACHE                2515
#const  global SCI_SETSCROLLWIDTHTRACKING          2516
#const  global SCI_GETSCROLLWIDTHTRACKING          2517
#const  global SCI_DELWORDRIGHTEND                 2518
#const  global SCI_COPYALLOWLINE                   2519
#const  global SCI_GETCHARACTERPOINTER             2520
#const  global SCI_SETKEYSUNICODE                  2521
#const  global SCI_GETKEYSUNICODE                  2522
#const  global SCI_INDICSETALPHA                   2523
#const  global SCI_INDICGETALPHA                   2524
#const  global SCI_SETEXTRAASCENT                  2525
#const  global SCI_GETEXTRAASCENT                  2526
#const  global SCI_SETEXTRADESCENT                 2527
#const  global SCI_GETEXTRADESCENT                 2528
#const  global SCI_MARKERSYMBOLDEFINED             2529
#const  global SCI_MARGINSETTEXT                   2530
#const  global SCI_MARGINGETTEXT                   2531
#const  global SCI_MARGINSETSTYLE                  2532
#const  global SCI_MARGINGETSTYLE                  2533
#const  global SCI_MARGINSETSTYLES                 2534
#const  global SCI_MARGINGETSTYLES                 2535
#const  global SCI_MARGINTEXTCLEARALL              2536
#const  global SCI_MARGINSETSTYLEOFFSET            2537
#const  global SCI_MARGINGETSTYLEOFFSET            2538
#const  global SCI_ANNOTATIONSETTEXT               2540
#const  global SCI_ANNOTATIONGETTEXT               2541
#const  global SCI_ANNOTATIONSETSTYLE              2542
#const  global SCI_ANNOTATIONGETSTYLE              2543
#const  global SCI_ANNOTATIONSETSTYLES             2544
#const  global SCI_ANNOTATIONGETSTYLES             2545
#const  global SCI_ANNOTATIONGETLINES              2546
#const  global SCI_ANNOTATIONCLEARALL              2547
#const  global SCI_ANNOTATIONSETVISIBLE            2548
#const  global SCI_ANNOTATIONGETVISIBLE            2549
#const  global SCI_ANNOTATIONSETSTYLEOFFSET        2550
#const  global SCI_ANNOTATIONGETSTYLEOFFSET        2551
#const  global SCI_ADDUNDOACTION                   2560
#const  global SCI_STARTRECORD                     3001
#const  global SCI_STOPRECORD                      3002
#const  global SCI_SETLEXER                        4001
#const  global SCI_GETLEXER                        4002
#const  global SCI_COLOURISE                       4003
#const  global SCI_SETPROPERTY                     4004
#const  global SCI_SETKEYWORDS                     4005
#const  global SCI_SETLEXERLANGUAGE                4006
#const  global SCI_LOADLEXERLIBRARY                4007
#const  global SCI_GETPROPERTY                     4008
#const  global SCI_GETPROPERTYEXPANDED             4009
#const  global SCI_GETPROPERTYINT                  4010
#const  global SCI_GETSTYLEBITSNEEDED              4011

#const  global SC_ALPHA_TRANSPARENT                0
#const  global SC_ALPHA_OPAQUE                     255
#const  global SC_ALPHA_NOALPHA                    256
#const  global SC_WRAPVISUALFLAG_NONE              $0000
#const  global SC_WRAPVISUALFLAG_END               $0001
#const  global SC_WRAPVISUALFLAG_START             $0002
#const  global SC_WRAPVISUALFLAGLOC_DEFAULT        $0000
#const  global SC_WRAPVISUALFLAGLOC_END_BY_TEXT    $0001
#const  global SC_WRAPVISUALFLAGLOC_START_BY_TEXT  $0002
#const  global SC_SEL_STREAM                       0
#const  global SC_SEL_RECTANGLE                    1
#const  global SC_SEL_LINES                        2
#const  global SCWS_INVISIBLE                      0
#const  global SCWS_VISIBLEALWAYS                  1
#const  global SCWS_VISIBLEAFTERINDENT             2
#const  global SC_EOL_CRLF                         0
#const  global SC_EOL_CR                           1
#const  global SC_EOL_LF                           2
#const  global SC_CP_DBCS                          1
#const  global SC_CP_UTF8                          65001
#const  global SC_MARK_CIRCLE                      0
#const  global SC_MARK_ROUNDRECT                   1
#const  global SC_MARK_ARROW                       2
#const  global SC_MARK_SMALLRECT                   3
#const  global SC_MARK_SHORTARROW                  4
#const  global SC_MARK_EMPTY                       5
#const  global SC_MARK_ARROWDOWN                   6
#const  global SC_MARK_MINUS                       7
#const  global SC_MARK_PLUS                        8
#const  global SC_MARK_VLINE                       9
#const  global SC_MARK_LCORNER                     10
#const  global SC_MARK_TCORNER                     11
#const  global SC_MARK_BOXPLUS                     12
#const  global SC_MARK_BOXPLUSCONNECTED            13
#const  global SC_MARK_BOXMINUS                    14
#const  global SC_MARK_BOXMINUSCONNECTED           15
#const  global SC_MARK_LCORNERCURVE                16
#const  global SC_MARK_TCORNERCURVE                17
#const  global SC_MARK_CIRCLEPLUS                  18
#const  global SC_MARK_CIRCLEPLUSCONNECTED         19
#const  global SC_MARK_CIRCLEMINUS                 20
#const  global SC_MARK_CIRCLEMINUSCONNECTED        21
#const  global SC_MARK_BACKGROUND                  22
#const  global SC_MARK_DOTDOTDOT                   23
#const  global SC_MARK_ARROWS                      24
#const  global SC_MARK_PIXMAP                      25
#const  global SC_MARK_FULLRECT                    26
#const  global SC_MARK_LEFTRECT                    27
#const  global SC_MARK_AVAILABLE                   28
#const  global SC_MARK_CHARACTER                   10000 

#const  global SC_MARKNUM_FOLDEREND                25
#const  global SC_MARKNUM_FOLDEROPENMID            26
#const  global SC_MARKNUM_FOLDERMIDTAIL            27
#const  global SC_MARKNUM_FOLDERTAIL               28
#const  global SC_MARKNUM_FOLDERSUB                29
#const  global SC_MARKNUM_FOLDER                   30
#const  global SC_MARKNUM_FOLDEROPEN               31
#const  global SC_MASK_FOLDERS                     $FE000000 

#const  global SC_MARGIN_SYMBOL                    0
#const  global SC_MARGIN_NUMBER                    1
#const  global SC_MARGIN_BACK                      2
#const  global SC_MARGIN_FORE                      3
#const  global SC_MARGIN_TEXT                      4
#const  global SC_MARGIN_RTEXT                     5 

#const  global STYLE_DEFAULT                       32
#const  global STYLE_LINENUMBER                    33
#const  global STYLE_BRACELIGHT                    34
#const  global STYLE_BRACEBAD                      35
#const  global STYLE_CONTROLCHAR                   36
#const  global STYLE_INDENTGUIDE                   37
#const  global STYLE_CALLTIP                       38
#const  global STYLE_LASTPREDEFINED                39
#const  global STYLE_MAX                           255 

#const  global SC_CHARSET_ANSI                     0
#const  global SC_CHARSET_DEFAULT                  1
#const  global SC_CHARSET_BALTIC                   186
#const  global SC_CHARSET_CHINESEBIG5              136
#const  global SC_CHARSET_EASTEUROPE               238
#const  global SC_CHARSET_GB2312                   134
#const  global SC_CHARSET_GREEK                    161
#const  global SC_CHARSET_HANGUL                   129
#const  global SC_CHARSET_MAC                      77
#const  global SC_CHARSET_OEM                      255
#const  global SC_CHARSET_RUSSIAN                  204
#const  global SC_CHARSET_SHIFTJIS                 128
#const  global SC_CHARSET_SYMBOL                   2
#const  global SC_CHARSET_TURKISH                  162
#const  global SC_CHARSET_JOHAB                    130
#const  global SC_CHARSET_HEBREW                   177
#const  global SC_CHARSET_ARABIC                   178
#const  global SC_CHARSET_VIETNAMESE               163
#const  global SC_CHARSET_THAI                     222
#const  global SC_CHARSET_8859_15                  1000

#const  global SC_CASE_MIXED                       0
#const  global SC_CASE_UPPER                       1
#const  global SC_CASE_LOWER                       2
#const  global SC_IV_NONE                          0
#const  global SC_IV_REAL                          1
#const  global SC_IV_LOOKFORWARD                   2
#const  global SC_IV_LOOKBOTH                      3

#const  global INDIC_MAX                           31
#const  global INDIC_PLAIN                         0
#const  global INDIC_SQUIGGLE                      1
#const  global INDIC_TT                            2
#const  global INDIC_DIAGONAL                      3
#const  global INDIC_STRIKE                        4
#const  global INDIC_HIDDEN                        5
#const  global INDIC_BOX                           6
#const  global INDIC_ROUNDBOX                      7
#const  global INDIC_CONTAINER                     8
#const  global INDIC0_MASK                         $20
#const  global INDIC1_MASK                         $40
#const  global INDIC2_MASK                         $80
#const  global INDICS_MASK                         $E0 

#const  global SC_PRINT_NORMAL                     0
#const  global SC_PRINT_INVERTLIGHT                1
#const  global SC_PRINT_BLACKONWHITE               2
#const  global SC_PRINT_COLOURONWHITE              3
#const  global SC_PRINT_COLOURONWHITEDEFAULTBG     4 

#const  global SCFIND_WHOLEWORD                    2
#const  global SCFIND_MATCHCASE                    4
#const  global SCFIND_WORDSTART                    $00100000
#const  global SCFIND_REGEXP                       $00200000
#const  global SCFIND_POSIX                        $00400000 

#const  global SC_FOLDLEVELBASE                    $00400
#const  global SC_FOLDLEVELWHITEFLAG               $01000
#const  global SC_FOLDLEVELHEADERFLAG              $02000
#const  global SC_FOLDLEVELNUMBERMASK              $00FFF 

#const  global SC_FOLDFLAG_LINEBEFORE_EXPANDED     $0002
#const  global SC_FOLDFLAG_LINEBEFORE_CONTRACTED   $0004
#const  global SC_FOLDFLAG_LINEAFTER_EXPANDED      $0008
#const  global SC_FOLDFLAG_LINEAFTER_CONTRACTED    $0010
#const  global SC_FOLDFLAG_LEVELNUMBERS            $0040 

#const  global SC_TIME_FOREVER                     10000000
#const  global SC_WRAP_NONE                        0
#const  global SC_WRAP_WORD                        1
#const  global SC_WRAP_CHAR                        2
#const  global SC_CACHE_NONE                       0
#const  global SC_CACHE_CARET                      1
#const  global SC_CACHE_PAGE                       2
#const  global SC_CACHE_DOCUMENT                   3

#const  global ANNOTATION_HIDDEN                   0
#const  global ANNOTATION_STANDARD                 1
#const  global ANNOTATION_BOXED                    2
#const  global EDGE_NONE                           0
#const  global EDGE_LINE                           1
#const  global EDGE_BACKGROUND                     2
#const  global SC_CURSORNORMAL                     -1
#const  global SC_CURSORWAIT                       4
#const  global UNDO_MAY_COALESCE                   1
#const  global VISIBLE_SLOP                        $01
#const  global VISIBLE_STRICT                      $04
#const  global CARET_SLOP                          $01
#const  global CARET_STRICT                        $04
#const  global CARET_JUMPS                         $10
#const  global CARET_EVEN                          $08

#const  global CARETSTYLE_INVISIBLE                0
#const  global CARETSTYLE_LINE                     1
#const  global CARETSTYLE_BLOCK                    2
#const  global SC_MOD_INSERTTEXT                   $1
#const  global SC_MOD_DELETETEXT                   $2
#const  global SC_MOD_CHANGESTYLE                  $4
#const  global SC_MOD_CHANGEFOLD                   $8
#const  global SC_PERFORMED_USER                   $10
#const  global SC_PERFORMED_UNDO                   $20
#const  global SC_PERFORMED_REDO                   $40
#const  global SC_MULTISTEPUNDOREDO                $80
#const  global SC_LASTSTEPINUNDOREDO               $100
#const  global SC_MOD_CHANGEMARKER                 $200
#const  global SC_MOD_BEFOREINSERT                 $400
#const  global SC_MOD_BEFOREDELETE                 $800
#const  global SC_MULTILINEUNDOREDO                $1000
#const  global SC_STARTACTION                      $2000
#const  global SC_MOD_CHANGEINDICATOR              $4000
#const  global SC_MOD_CHANGELINESTATE              $8000
#const  global SC_MOD_CHANGEMARGIN                 $10000
#const  global SC_MOD_CHANGEANNOTATION             $20000
#const  global SC_MOD_CONTAINER                    $40000
#const  global SC_MODEVENTMASKALL                  $7FFFF

#const  global SCK_DOWN                            300
#const  global SCK_UP                              301
#const  global SCK_LEFT                            302
#const  global SCK_RIGHT                           303
#const  global SCK_HOME                            304
#const  global SCK_END                             305
#const  global SCK_PRIOR                           306
#const  global SCK_NEXT                            307
#const  global SCK_DELETE                          308
#const  global SCK_INSERT                          309
#const  global SCK_ESCAPE                          7
#const  global SCK_BACK                            8
#const  global SCK_TAB                             9
#const  global SCK_RETURN                          13
#const  global SCK_ADD                             310
#const  global SCK_SUBTRACT                        311
#const  global SCK_DIVIDE                          312
#const  global SCK_WIN                             313
#const  global SCK_RWIN                            314
#const  global SCK_MENU                            315

#const  global SCMOD_NORM                          0
#const  global SCMOD_SHIFT                         1
#const  global SCMOD_CTRL                          2
#const  global SCMOD_ALT                           4

#const  global SCLEX_CONTAINER                     0
#const  global SCLEX_NULL                          1
#const  global SCLEX_PYTHON                        2
#const  global SCLEX_CPP                           3
#const  global SCLEX_HTML                          4
#const  global SCLEX_XML                           5
#const  global SCLEX_PERL                          6
#const  global SCLEX_SQL                           7
#const  global SCLEX_VB                            8
#const  global SCLEX_PROPERTIES                    9
#const  global SCLEX_ERRORLIST                     10
#const  global SCLEX_MAKEFILE                      11
#const  global SCLEX_BATCH                         12
#const  global SCLEX_LATEX                         14
#const  global SCLEX_LUA                           15
#const  global SCLEX_DIFF                          16
#const  global SCLEX_CONF                          17
#const  global SCLEX_PASCAL                        18
#const  global SCLEX_AVE                           19
#const  global SCLEX_ADA                           20
#const  global SCLEX_LISP                          21
#const  global SCLEX_RUBY                          22
#const  global SCLEX_EIFFEL                        23
#const  global SCLEX_EIFFELKW                      24
#const  global SCLEX_TCL                           25
#const  global SCLEX_NNCRONTAB                     26
#const  global SCLEX_BULLANT                       27
#const  global SCLEX_VBSCRIPT                      28
#const  global SCLEX_ASP                           SCLEX_HTML
#const  global SCLEX_PHP                           SCLEX_HTML
#const  global SCLEX_BAAN                          31
#const  global SCLEX_MATLAB                        32
#const  global SCLEX_SCRIPTOL                      33
#const  global SCLEX_ASM                           34
#const  global SCLEX_CPPNOCASE                     35
#const  global SCLEX_FORTRAN                       36
#const  global SCLEX_F77                           37
#const  global SCLEX_CSS                           38
#const  global SCLEX_POV                           39
#const  global SCLEX_LOUT                          40
#const  global SCLEX_ESCRIPT                       41
#const  global SCLEX_PS                            42
#const  global SCLEX_NSIS                          43
#const  global SCLEX_MMIXAL                        44
#const  global SCLEX_CLW                           45
#const  global SCLEX_CLWNOCASE                     46
#const  global SCLEX_LOT                           47
#const  global SCLEX_YAML                          48
#const  global SCLEX_TEX                           49
#const  global SCLEX_METAPOST                      50
#const  global SCLEX_POWERBASIC                    51
#const  global SCLEX_FORTH                         52
#const  global SCLEX_ERLANG                        53
#const  global SCLEX_OCTAVE                        54
#const  global SCLEX_MSSQL                         55
#const  global SCLEX_VERILOG                       56
#const  global SCLEX_KIX                           57
#const  global SCLEX_GUI4CLI                       58
#const  global SCLEX_SPECMAN                       59
#const  global SCLEX_AU3                           60
#const  global SCLEX_APDL                          61
#const  global SCLEX_BASH                          62
#const  global SCLEX_ASN1                          63
#const  global SCLEX_VHDL                          64
#const  global SCLEX_CAML                          65
#const  global SCLEX_BLITZBASIC                    66
#const  global SCLEX_PUREBASIC                     67
#const  global SCLEX_HASKELL                       68
#const  global SCLEX_PHPSCRIPT                     69
#const  global SCLEX_TADS3                         70
#const  global SCLEX_REBOL                         71
#const  global SCLEX_SMALLTALK                     72
#const  global SCLEX_FLAGSHIP                      73
#const  global SCLEX_CSOUND                        74
#const  global SCLEX_FREEBASIC                     75
#const  global SCLEX_INNOSETUP                     76
#const  global SCLEX_OPAL                          77
#const  global SCLEX_SPICE                         78
#const  global SCLEX_D                             79
#const  global SCLEX_CMAKE                         80
#const  global SCLEX_GAP                           81
#const  global SCLEX_PLM                           82
#const  global SCLEX_PROGRESS                      83
#const  global SCLEX_ABAQUS                        84
#const  global SCLEX_ASYMPTOTE                     85
#const  global SCLEX_R                             86
#const  global SCLEX_MAGIK                         87
#const  global SCLEX_POWERSHELL                    88
#const  global SCLEX_MYSQL                         89
#const  global SCLEX_PO                            90
#const  global SCLEX_TAL                           91
#const  global SCLEX_COBOL                         92
#const  global SCLEX_TACL                          93
#const  global SCLEX_SORCUS                        94
#const  global SCLEX_POWERPRO                      95
#const  global SCLEX_NIMROD                        96
#const  global SCLEX_SML                           97

#const  global SCE_B_DEFAULT                       0
#const  global SCE_B_COMMENT                       1
#const  global SCE_B_NUMBER                        2
#const  global SCE_B_KEYWORD                       3
#const  global SCE_B_STRING                        4
#const  global SCE_B_PREPROCESSOR                  5
#const  global SCE_B_OPERATOR                      6
#const  global SCE_B_IDENTIFIER                    7
#const  global SCE_B_DATE                          8
#const  global SCE_B_STRINGEOL                     9
#const  global SCE_B_KEYWORD2                      10
#const  global SCE_B_KEYWORD3                      11
#const  global SCE_B_KEYWORD4                      12
#const  global SCE_B_CONSTANT                      13
#const  global SCE_B_ASM                           14
#const  global SCE_B_LABEL                         15
#const  global SCE_B_ERROR                         16
#const  global SCE_B_HEXNUMBER                     17
#const  global SCE_B_BINNUMBER                     18
;|========.===========================.============[                    ]=====|
#module   Scit
#define global _SciBox(%1="",%2=$50000000,%3=$0,%4=_NULL,%5=_NULL) winobj "Scintilla",%1,%3,%2,_Iif(%4==_NULL,_Hbms@Func(29),%4),_Iif(%5==_NULL,_Hbms@Func(30),%5) :_Mint@Func = objinfo(stat,2)
;|============================================================================|
#global
#endif
