;|=================================================[  UhspXreg.as       ]=====|
#ifndef        __UHSP_XREG__
#define global __UHSP_XREG__
#ifndef        __UHSP_FUNC__
#include "UhspFunc.as"
#endif
;|========.===========================.============[                    ]=====|
;uselib  "BREGEXP.DLL"
#uselib  "BREGONIG.DLL"
#func   global __BMatch                  "BMatch"                 sptr,sptr,sptr,sptr,sptr
#func   global __BSubst                  "BSubst"                 sptr,sptr,sptr,sptr,sptr
#func   global __BTrans                  "BTrans"                 sptr,sptr,sptr,sptr,sptr
#func   global __BSplit                  "BSplit"                 sptr,sptr,sptr,sptr,sptr,sptr
#func   global __BRegfree                "BRegfree"               sptr
#func   global __BRegexpVersion          "BRegexpVersion"
;|========.===========================.============[                    ]=====|
#module   Xreg
           dim _Lreg@Xreg           ,   44 :                   ;BREGEXP  / 
           dim _Preg@Xreg           ,    1 :                   ;
           dim _Sreg@Xreg                  :                   ;         / start  point
           dim _Ereg@Xreg                  :                   ;         / end    point
           dim _Treg@Xreg           ,    1 :                   ;         / target point
;|========.===========================.============[                    ]=====|
#defcfunc Xreg_Bmatch str p1,str p2,int p3,local ss,local nn,local rr
          __BRegfree _Preg :_Preg = 0      :ss = p1,p2                               :_Hstr@Func = ""
            if (p3   <  0) {return -1}
          __BMatch varptr(ss(1)),varptr(ss)+p3,varptr(ss)+strlen(ss),varptr(_Preg),varptr(rr)
            if (stat <= 0) {return -1}
              dupptr _Lreg ,_Preg,44,4     :dupptr  _Sreg,_Lreg(8),_Lreg(10)*4+4,4   : dupptr _Ereg,_Lreg(9),_Lreg(10)*4+4,4
                     _Treg   = varptr(ss)  :rr(1) = _Lreg(10)+1
              repeat  rr(1)
                      nn     =  _Ereg(cnt)-_Treg,_Ereg(cnt)-_Sreg(cnt),_Sreg(cnt)-_Treg
                      ss(3) += strf("%d,%d,%s ",nn-nn(1)-p3,nn(1),strmid(ss,nn(2),nn(1)))
              loop                                                                   :_Hstr@Func = strtrim(ss(3),2)
;         __BRegfree _Preg :_Preg = 0
return  rr(1)
#defcfunc Xreg_Bsubst str p1,str p2,local ss,local nn,local rr
          __BRegfree _Preg :_Preg = 0      :ss = p1,p2                               :_Hstr@Func = ""
          __BSubst varptr(ss(1)),varptr(ss),varptr(ss)+strlen(ss),varptr(_Preg),varptr(rr)
            if (stat <= 0) {return -1} else {rr(1) = stat}
              dupptr _Lreg ,_Preg,44,4     :dupptr     nn,_Lreg,_Lreg(1)-_Lreg(0),2  :_Hstr@Func = nn
          __BRegfree _Preg :_Preg = 0
return  rr(1)
#defcfunc Xreg_Btrans str p1,str p2,local ss,local nn,local rr
          __BRegfree _Preg :_Preg = 0      :ss = p1,p2                               :_Hstr@Func = ""
          __BTrans varptr(ss(1)),varptr(ss),varptr(ss)+strlen(ss),varptr(_Preg),varptr(rr)
            if (stat <= 0) {return -1} else {rr(1) = stat}
              dupptr _Lreg ,_Preg,44,4     :dupptr    nn,_Lreg,_Lreg(1)-_Lreg(0),2   :_Hstr@Func = nn
          __BRegfree _Preg :_Preg = 0
return  rr(1)
#defcfunc Xreg_Bsplit str p1,str p2,array p3,int p4,local ss,local nn,local rr
          __BRegfree _Preg :_Preg = 0      :ss = p1,p2                               :_Hstr@Func = ""
          __BSplit varptr(ss(1)),varptr(ss),varptr(ss)+strlen(ss),p4,varptr(_Preg),varptr(rr)
            if (stat <= 0) {return -1} else {rr(1) = stat}
              dupptr _Lreg ,_Preg,44,4     :dupptr    nn,_Lreg(3),8*rr(1),4          : sdim p3
              repeat rr(1) : p3(cnt) = strmid(ss,nn(cnt*2)-varptr(ss),nn(cnt*2+1)-nn(cnt*2)) :loop
          __BRegfree _Preg :_Preg = 0
return  rr(1)
#defcfunc Xreg_Gmatch str p1,str p2,int p3,local ss,local nn,local rr,local ii
                                            :ss = p1,p2,"",""                        :_Hstr@Func = ""
            repeat strlen(ss),p3            :ii = Xreg_BMatch(ss,ss(1),cnt)          : if (ii == -1) {break}
         : split _Hstr@Func,",",nn
                   if (rr   != 0) {nn    = str(int(nn)+ii(1))}                       : ii(1) =  int(nn)+int(nn(1))
                                   ss(2) = strf("%d,%d,%s",nn,nn(1),nn(2))           : ss(3)+= " "+ss(2)
                   if (stat >= 0) {rr++     :continue cnt+(_Ereg-_Treg-cnt)}
            loop                                                                     :_Hstr@Func = ss(3)
return  rr
;|========.===========================.============[                    ]=====|
#define global ctype _Bmatch(%1="",%2="",%3=0)                          Xreg_Bmatch(%1,%2,%3)
#define global ctype _Gmatch(%1="",%2="",%3=0)                          Xreg_Gmatch(%1,%2,%3)
#define global ctype _Bsubst(%1="",%2="")                               Xreg_Bsubst(%1,%2)
#define global ctype _Btrans(%1="",%2="")                               Xreg_Btrans(%1,%2)
#define global ctype _Bsplit(%1="",%2="",%3=0,%4=0)                     Xreg_Bsplit(%1,%2,%3,%4)
;|============================================================================|
#global
#endif
