;|=================================================[  UhspChar.as       ]=====|
#ifndef        __UHSP_CHAR__
#define global __UHSP_CHAR__
#ifndef        __UHSP_FUNC__
#include "UhspFunc.as"
#endif
;|========.===========================.============[                    ]=====|
#module   Char
#defcfunc Char_Chr  int p1,int p2,local rr
          rr = ""     :if (p2) {wpoke rr,0,p1 :return cnvwtos(rr)}     :wpoke rr,0,p1
return  rr
#defcfunc Char_Asc  str p1,int p2,local rr
          rr = p1,p1  :if (p2) {cnvstow rr,rr(1)}
return    wpeek(rr)
#defcfunc Char_Fchr str p1,int p2,int p3,int p4,local rr,local ss
                                  ss  = p1:rr  = 0,Func_SizeOf(ss),(-1+(2*p3)),0
                              if (p2    > rr(1)) {return -2}
          if (p4 <= $FF) {repeat :rr  = p2+(cnt*rr(2)) :await
                              if (rr    <    0 ) or (rr >= rr(1)) {rr = -1 :break}   :if (peek(ss,rr)  == p4) {break} :loop}
        else             {repeat :rr  = p2+(cnt*rr(2)) :await
                              if (rr(2) >    0 ) {poke rr(3),0,peek(ss,rr) :if (rr+rr(2)  >= rr(1)) {rr = -1  :break}
                                                  poke rr(3),1,peek(ss,rr+rr(2))}
                            else                 {poke rr(3),1,peek(ss,rr) :if (rr+rr(2)  <=    0 ) {rr = -1  :break}
                                                  poke rr(3),0,peek(ss,rr+rr(2))}
                              if (rr    <    0 ) or (rr >= rr(1)) {rr = -1 :break}   :if (wpeek(rr(3)) == p4) {break} :loop
                              if (rr    >    0 ) and(rr(2) <  0 ) {rr--   }}
return  rr
#defcfunc Char_Rchr2 var p1,int p2,int p3,local ii,local jj,local rr
                                  :ii = Func_SizeOf(p1)
          if (p2 <= $FF) {repeat  ii :     if  ( peek(p1,cnt) == p2)   { poke p1,cnt,p3} :loop}
        else             {repeat  ii :poke jj,0, peek(p1,cnt)          :if (cnt+1 >= ii) {break}
                                     :poke jj,1, peek(p1,cnt+1)
                                     :     if  (wpeek(jj)     == p2)   {wpoke p1,cnt,p3} :loop}
return  p1
#defcfunc Char_Bstr str p1,str p2,str p3,int p4,local rr,local ss
          sdim ss,512    :ss = p1
          if (p2 ==  "") {rr =  0,instr(ss,rr,p3)} else {if (p3 == "") {rr = instr(ss,p4,p2)+strlen@hsp(p2)+p4,strlen@hsp(ss)-rr}
                                                   else                {rr = instr(ss,p4,p2)+strlen@hsp(p2)+p4,instr(ss,rr,p3) }}
return    strmid(ss,rr,rr(1))
#defcfunc Char_Cstr str p1,str p2,str p3,local rr
          rr = p1                    :if (p2 != "") {strrep rr,p2,p3    :return rr}
return    getpath(rr,16)
#defcfunc Char_Istr str p1,int p2,str p3,int p4,local ss
          ss = p1,p3                 :if (p4      ) {ss = getpath(ss,16),getpath(ss(1),16)}
return    instr(ss,p2,ss(1))
#defcfunc Char_Dstr str p1,int p2,int p3,local ss,local rr
          ss = p1        :rr = p3    :if (p3  = -1) {rr = strlen@hsp(ss)-p2}
return    strmid(ss,p2,rr)
#defcfunc Char_Align  str p1,int p2,int p3,local ss,local ii,local rr
          if (p3  ==  1) {ss = p1    :ii =  strlen@hsp(ss)             :rr = strf("%"+abs(p2)*-1+"s",strf("%"+(ii+(abs(p2)-ii)/2)+"s",p1))}
     else:if (p3  ==  2) {ss = p1    :if (p2   <  0)                   {rr = strmid(ss,strlen@hsp(ss)+p2,abs(p2))} else {rr = strmid(ss,0,p2)}}
     else                {ii = "%"+p2+"s"                              :rr =  strf(ii,p1)}
return  rr
;|========.===========================.============[                    ]=====|
#define global ctype _Chr(%1=0,%2=0)                                    Char_Chr(%1,%2)
#define global ctype _Asc(%1="",%2=0)                                   Char_Asc(%1,%2)
#define global ctype _Fchr(%1="",%2=0,%3=1,%4=10)                       Char_Fchr(%1,%2,%3,%4)
#define global ctype _Rchr2(%1=_Ures@Func,%2=92,%3=47)                  Char_Rchr2(%1,%2,%3)
#define global ctype _Bstr(%1="",%2="",%3="",%4=0)                      Char_Bstr(%1,%2,%3,%4)
#define global ctype _Cstr(%1="",%2="",%3="")                           Char_Cstr(%1,%2,%3)
#define global ctype _Istr(%1="",%2=0,%3="",%4=0)                       Char_Istr(%1,%2,%3,%4)
#define global ctype _Dstr(%1="",%2=0,%3=-1)                            Char_Dstr(%1,%2,%3)
#define global ctype _Align(%1="",%2=0,%3=0)                            Char_Align(%1,%2,%3)
;|============================================================================|
#global
#endif
