;|=================================================[  UhspClip.as       ]=====|
#ifndef        __UHSP_CLIP__
#define global __UHSP_CLIP__
#ifndef        __UHSP_FUNC__
#include "UhspFunc.as"
#endif
;|========.===========================.============[                    ]=====|
#module   Clip
#defcfunc Clip_TxtClip int p1,str p2,local ii,local jj,local rr
                                                               :  rr    =  p2
          switch p1
            case  1 :__GlobalAlloc $42,strlen@hsp(rr)+1        :  ii    =  stat
                     __GlobalLock ii                           :  jj    =  stat
                     __LstrCpy jj,rr                           :__GlobalUnlock ii
                     __OpenClipboard hwnd                      :__EmptyClipboard
                     __SetClipboardData 1,ii                   :__CloseClipboard :swbreak
            case  2 :__OpenClipboard hwnd    :__EmptyClipboard :__CloseClipboard :swbreak
            default :__IsClipboardFormatAvailable 1            :  if (stat == 0) {return 0}
                     __OpenClipboard hwnd                      ;__CountClipboardFormats
                     __GetClipboardData 1                      :  ii    =  stat
                     __GlobalSize ii                           :  jj    =  stat
                       sdim rr,jj+1                            :__GlobalAlloc $42,jj+1
                     __GlobalLock ii                           :  jj    =  stat
                     __LstrCpy varptr(rr),jj :__GlobalUnlock ii:__CloseClipboard :swbreak
          swend
return   rr
#defcfunc Clip_BmpClip int p1,int p2,int p3,int p4,int p5,local ii,local jj,local nn,local rr
          switch p1
            case  1 :Func_Bswap -3,_BCLP
                     buffer@hsp _BCLP,p4,p5
                     gcopy  _Mint@Func(1),p2,p3,p4,p5          :  Func_Bswap -1
                     rr = Func_BmpCreate(p4,p5,0,0,_BCLP)      :__OpenClipboard   hwnd
                                                               :__EmptyClipboard
                     __SetClipboardData $2,rr                  :__DeleteObject rr
                     buffer@hsp _BCLP,640,480                  :  Func_Bswap -1
                                                               :__CloseClipboard :swbreak
            case  2 :__OpenClipboard hwnd    :__EmptyClipboard :__CloseClipboard :swbreak
            default :__IsClipboardFormatAvailable 2            :  if (stat == 0) {return 0}
                     __OpenClipboard hwnd
                     __GetClipboardData $2                     :  rr    =  stat
                     __CreateCompatibleDC hdc                  :  jj    =  stat
                     __SelectObject  jj,rr                     :  jj(1) =  stat
                     __GetObjectA    rr, 0,0                   :  ii    =  stat  :sdim nn,ii
                     __GetObjectA    rr,ii,varptr(nn)          :
                     __BitBlt    hdc,p2,p3,wpeek(nn,4),wpeek(nn,8),jj,0,0,$00CC0020
                     __SelectObject  jj,jj(1) :__DeleteDC  jj  :__CloseClipboard
                if (_Mint@Func(2)){__InvalidateRect hwnd,0,1}                    :swbreak
          swend
return  rr
;|========.===========================.============[                    ]=====|
#define global ctype _TxtClip(%1=0,%2="")                               Clip_TxtClip(%1,%2)
#define global ctype _BmpClip(%1=0,%2=0,%3=0,%4=ginfo_sx,%5=ginfo_sy)   Clip_BmpClip(%1,%2,%3,%4,%5)
;|============================================================================|
#global
#endif
