;|=================================================[  UhspHash.as       ]=====|
#ifndef        __UHSP_HASH__
#define global __UHSP_HASH__
#ifndef        __UHSP_FUNC__
#include "UhspFunc.as"
#endif
;|========.===========================.============[                    ]=====|
#module   Hash _Hn0,_Hn1
#modinit  str p1,var p2
         _Hn0 =  p1:_Hn1 =  p2
return
#modcfunc Hash_GetKey
return   _Hn0
#modcfunc Hash_GetValue
return   _Hn1
#modfunc  Hash_PutValue var p1
         _Hn1 =  p1
return
#deffunc  Hash_PutData str p1,var p2,array p3,local ii
          if (vartype(p3) != 5) {dimtype p3,5,1}
          repeat length(p3)+1   :if (     varuse(p3(cnt))^1)     {newmod p3,Hash,p1,p2         :break}
                                 if (Hash_GetKey(p3(cnt)) == p1) {Hash_PutValue p3(cnt),p2     :break} :loop
return
#defcfunc Hash_GetData str p1,array p2,local ii,local rr
          repeat length(p2)+1   :if (     varuse(p2(cnt))^1)     {rr = _NULL                   :break}
                                 if (Hash_GetKey(p2(cnt)) == p1) {rr =  Hash_GetValue(p2(cnt)) :break} :loop
return  rr
;|========.===========================.============[                    ]=====|
#define global       _IniHash(%1=_Utbl@Func)                            dimtype %1,5,1
#define global       _PutHash(%1=0,%2=0,%3=_Utbl@Func) _Uany@Func = %2 :Hash_PutData ""+%1,_Uany@Func,%3
#define global ctype _GetHash(%1=0,%2=_Utbl@Func)                       Hash_GetData(""+%1,%2)
#define global ctype _KeyHash(%1=0,%2=_Utbl@Func)                       Hash_GetKey(%2(%1))
#define global ctype _ValHash(%1=0,%2=_Utbl@Func)                       Hash_GetValue(%2(%1))
#define global       _CntHash(%1=0,%2=_Utbl@Func) if (_GetHash(%1,%2) != _NULL) {_PutHash %1,_GetHash(%1)+1,%2} else {_PutHash %1,1,%2}
;|============================================================================|
#global
#endif
