;|=================================================[  UhspMath.as       ]=====|
#ifndef        __UHSP_MATH__
#define global __UHSP_MATH__
;|========.===========================.============[                    ]=====|
#ifndef        __UHSP_FUNC__
#include "UhspFunc.as"
#endif
;|========.===========================.============[                    ]=====|
#module   Math
#defcfunc Math_Gcd int p1,int p2
          if (p2 ==  0) {return p1}
return    Math_Gcd (p2,p1\p2)
#defcfunc Math_Lcm int p1,int p2
          if (p2 ==  0) {return p1}
return   (p1*p2)/Math_Gcd(p1,p2)
#defcfunc Math_2Float  double p1,local ii
          ii  =  p1 
return    lpeek(ii)>>29&7|(p1<0)<<31|lpeek(ii,4)-(p1!0)*$38000000<<3
#defcfunc Math_2Double int p1,local ii,local rr
          ii  = (p1&$80000000)|(((p1&$7FFFFFFF)>>3)+((p1&$7FFFFFFF)!0)*$38000000)
          rr  =  0.0  :lpoke rr,4,ii:lpoke rr,0,p1<<29
return  rr
;|========.===========================.============[                    ]=====|
#define global ctype _Max(%1=0,%2=0)       (%1*(%1>=%2)+%2*(%1<%2))
#define global ctype _Min(%1=0,%2=0)       (%1*(%1<=%2)+%2*(%1>%2))
#define global ctype _MakeWord(%1=0,%2=0)  (%1    &$FF|(%2&$FF)<<8)
#define global ctype _HiByte(%1=0)         (%1>> 8&$FF)
#define global ctype _LoByte(%1=0)         (%1    &$FF)
#define global ctype _2Bend(%1=0)          (%1>> 8&$FF)|((%1&$7F)    <<8)|((%1>> 7 &$01)*$1FFFF<<15)
#define global ctype _3Bend(%1=0)          (%1>> 8&$7F)|((%1&$FF)    <<8)|((%1>>24)&$80)
#define global ctype _4Bend(%1=0)          (%1>>24&$FF)|((%1>>16&$FF)<<8)|((%1>> 8 &$FF)<<16)|((%1&$FF)<<24)
;|========.===========================.============[                    ]=====|
#define global ctype _Gcd(%1=0,%2=0)                                    Math_Gcd(%1,%2)
#define global ctype _Lcm(%1=0,%2=0)                                    Math_Lcm(%1,%2)
#define global ctype _2Float(%1=0.0)                                    Math_2Float(%1)
#define global ctype _2Double(%1=0)                                     Math_2Double(%1)
;|============================================================================|
#global
#endif
